searchData={"items":[{"type":"module","title":"Igniter","doc":"Tools for generating and patching code into an Elixir project.","ref":"Igniter.html"},{"type":"function","title":"Igniter.add_issue/2","doc":"Adds an issue to the issues list. Any issues will prevent writing and be displayed to the user.","ref":"Igniter.html#add_issue/2"},{"type":"function","title":"Igniter.add_notice/2","doc":"Adds a notice to the notices list. Notices are displayed to the user once the igniter finishes running.","ref":"Igniter.html#add_notice/2"},{"type":"function","title":"Igniter.add_task/3","doc":"Adds a task to the tasks list. Tasks will be run after all changes have been commited","ref":"Igniter.html#add_task/3"},{"type":"function","title":"Igniter.add_warning/2","doc":"Adds a warning to the warnings list. Warnings will not prevent writing, but will be displayed to the user.","ref":"Igniter.html#add_warning/2"},{"type":"function","title":"Igniter.apply_and_fetch_dependencies/2","doc":"Applies the current changes to the `mix.exs` in the Igniter and fetches dependencies.\n\nReturns the remaining changes in the Igniter if successful.","ref":"Igniter.html#apply_and_fetch_dependencies/2"},{"type":"function","title":"Options - Igniter.apply_and_fetch_dependencies/2","doc":"* `:error_on_abort?` - If `true`, raises an error if the user aborts the operation. Returns the original igniter if not.\n* `:yes` - If `true`, automatically applies the changes without prompting the user.","ref":"Igniter.html#apply_and_fetch_dependencies/2-options"},{"type":"function","title":"Igniter.assign/2","doc":"","ref":"Igniter.html#assign/2"},{"type":"function","title":"Igniter.assign/3","doc":"Stores the key/value pair in `igniter.assigns`","ref":"Igniter.html#assign/3"},{"type":"function","title":"Igniter.changed?/1","doc":"Returns true if the igniter or source provided has changed","ref":"Igniter.html#changed?/1"},{"type":"function","title":"Igniter.changed?/2","doc":"Returns true if any of the files specified in `paths` have changed.","ref":"Igniter.html#changed?/2"},{"type":"function","title":"Igniter.compose_task/4","doc":"Finds the `Igniter.Mix.Task` task by name and composes it with `igniter`.\n\nIf the task doesn't exist, a `fallback` function may be provided. This\nfunction should accept and return the `igniter`.","ref":"Igniter.html#compose_task/4"},{"type":"function","title":"Argument handling - Igniter.compose_task/4","doc":"This function calls the task's `igniter/1` (or `igniter/2`) callback, setting\n`igniter.args` using the current `igniter.args.argv_flags`. This prevents\ncomposed tasks from accidentally consuming positional arguments. If you\nwish the composed task to access additional arguments, you must explicitly\npass an `argv` list.\n\nAdditionally, you must declare other tasks you are composing with in your\ntask's `Igniter.Mix.Task.Info` struct using the `:composes` key. Without\nthis, you'll see unexpected argument errors if a flag that a composed task\nuses is passed without you explicitly declaring it in your `:schema`.","ref":"Igniter.html#compose_task/4-argument-handling"},{"type":"function","title":"Example - Igniter.compose_task/4","doc":"def info(_argv, _parent) do\n      %Igniter.Mix.Task.Info{\n        ...,\n        composes: [\n          \"other.task1\",\n          \"other.task2\"\n        ]\n      }\n\n    def igniter(igniter) do\n      igniter\n      # other.task1 will see igniter.args.argv_flags as its args\n      |> Igniter.compose_task(\"other.task1\")\n      # other.task2 will see an additional arg and flag\n      |> Igniter.compose_task(\"other.task2\", [\"arg\", \"--flag\"] ++ igniter.argv.argv_flags)\n    end","ref":"Igniter.html#compose_task/4-example"},{"type":"function","title":"Igniter.copy_template/5","doc":"Copies an EEx template file from  the source path to the target path.\n\nAccepts the same options as `create_new_file/4`.","ref":"Igniter.html#copy_template/5"},{"type":"function","title":"Igniter.create_new_elixir_file/4","doc":"","ref":"Igniter.html#create_new_elixir_file/4"},{"type":"function","title":"Igniter.create_new_file/4","doc":"Creates a new file in the project with the provided string contents. Adds an error if it already exists.","ref":"Igniter.html#create_new_file/4"},{"type":"function","title":"Options - Igniter.create_new_file/4","doc":"- `:on_exists` - The action to take if the file already exists. Can be\n  - `:error` (default) - Adds an error that prevents any eventual write.\n  - `:warning` - Warns when writing but continues (without overwriting)\n  - `:skip` - Skips writing the file without a warning\n  - `:overwrite` - Warns when writing and overwrites the content with the new content","ref":"Igniter.html#create_new_file/4-options"},{"type":"function","title":"Igniter.create_or_update_elixir_file/4","doc":"Creates the given file in the project with the provided string contents, or updates it with a function of type `zipper_updater()` if it already exists.","ref":"Igniter.html#create_or_update_elixir_file/4"},{"type":"function","title":"Igniter.create_or_update_file/4","doc":"Creates the given file in the project with the provided string contents, or updates it with a function as in `update_file/3` (or with `zipper_updater()` for elixir files) if it already exists.","ref":"Igniter.html#create_or_update_file/4"},{"type":"function","title":"Igniter.do_or_dry_run/2","doc":"Executes or dry-runs a given Igniter.","ref":"Igniter.html#do_or_dry_run/2"},{"type":"function","title":"Igniter.exists?/2","doc":"Checks if a file exists on the file system or in the igniter.","ref":"Igniter.html#exists?/2"},{"type":"function","title":"Igniter.has_changes?/2","doc":"Returns whether the current Igniter has pending changes.","ref":"Igniter.html#has_changes?/2"},{"type":"function","title":"Igniter.include_all_elixir_files/1","doc":"This function stores in the igniter if its been run before, so it is only run once, which is expensive.","ref":"Igniter.html#include_all_elixir_files/1"},{"type":"function","title":"Igniter.include_existing_elixir_file/3","doc":"","ref":"Igniter.html#include_existing_elixir_file/3"},{"type":"function","title":"Igniter.include_existing_file/3","doc":"Includes the given file in the project, expecting it to exist. Does nothing if its already been added.","ref":"Igniter.html#include_existing_file/3"},{"type":"function","title":"Igniter.include_glob/2","doc":"Includes all files matching the given glob, expecting them all (for now) to be elixir files.","ref":"Igniter.html#include_glob/2"},{"type":"function","title":"Igniter.include_or_create_elixir_file/3","doc":"","ref":"Igniter.html#include_or_create_elixir_file/3"},{"type":"function","title":"Igniter.include_or_create_file/3","doc":"Includes or creates the given file in the project with the provided contents. Does nothing if its already been added.","ref":"Igniter.html#include_or_create_file/3"},{"type":"function","title":"Igniter.install/4","doc":"Installs a package as if calling `mix igniter.install`\n\nSee `mix igniter.install` for information on the package format.","ref":"Igniter.html#install/4"},{"type":"function","title":"Options - Igniter.install/4","doc":"- `append?` - If `true`, appends the package to the existing list of packages instead of prepending. Defaults to `false`.","ref":"Igniter.html#install/4-options"},{"type":"function","title":"Examples - Igniter.install/4","doc":"Igniter.install(igniter, \"ash\")\n\n  Igniter.install(igniter, \"ash_authentication@2.0\", [\"--authentication-strategies\", \"password,magic_link\"])","ref":"Igniter.html#install/4-examples"},{"type":"function","title":"Igniter.mkdir/2","doc":"Creates a folder in the project.","ref":"Igniter.html#mkdir/2"},{"type":"function","title":"Igniter.move_file/4","doc":"","ref":"Igniter.html#move_file/4"},{"type":"function","title":"Igniter.new/0","doc":"Returns a new igniter","ref":"Igniter.html#new/0"},{"type":"type","title":"Igniter.t/0","doc":"","ref":"Igniter.html#t:t/0"},{"type":"function","title":"Igniter.update_all_elixir_files/2","doc":"Runs an update over all elixir files","ref":"Igniter.html#update_all_elixir_files/2"},{"type":"function","title":"Igniter.update_assign/4","doc":"","ref":"Igniter.html#update_assign/4"},{"type":"function","title":"Igniter.update_elixir_file/3","doc":"Updates the source code of the given elixir file","ref":"Igniter.html#update_elixir_file/3"},{"type":"function","title":"Igniter.update_file/4","doc":"Updates a given file's `Rewrite.Source`","ref":"Igniter.html#update_file/4"},{"type":"function","title":"Igniter.update_glob/3","doc":"Updates all files matching the given glob with the given zipper function.\n\nAdds any new files matching that glob to the igniter first.","ref":"Igniter.html#update_glob/3"},{"type":"type","title":"Igniter.zipper_updater/0","doc":"","ref":"Igniter.html#t:zipper_updater/0"},{"type":"module","title":"Igniter.Test","doc":"Tools for testing with igniter.","ref":"Igniter.Test.html"},{"type":"function","title":"Igniter.Test.apply_igniter/1","doc":"Fakes applying the changes of an igniter.\n\nThis function returns any tasks, errors, warnings.","ref":"Igniter.Test.html#apply_igniter/1"},{"type":"function","title":"Igniter.Test.apply_igniter!/1","doc":"Applies an igniter, raising an error if there are any issues.\n\nSee `apply_igniter/1` for more.","ref":"Igniter.Test.html#apply_igniter!/1"},{"type":"macro","title":"Igniter.Test.assert_creates/3","doc":"","ref":"Igniter.Test.html#assert_creates/3"},{"type":"macro","title":"Igniter.Test.assert_has_patch/3","doc":"","ref":"Igniter.Test.html#assert_has_patch/3"},{"type":"macro","title":"Igniter.Test.assert_unchanged/1","doc":"","ref":"Igniter.Test.html#assert_unchanged/1"},{"type":"macro","title":"Igniter.Test.assert_unchanged/2","doc":"","ref":"Igniter.Test.html#assert_unchanged/2"},{"type":"function","title":"Igniter.Test.diff/2","doc":"Return the current `igniter` diff.","ref":"Igniter.Test.html#diff/2"},{"type":"function","title":"Options - Igniter.Test.diff/2","doc":"* `:only` - Only return the diff for this file or files","ref":"Igniter.Test.html#diff/2-options"},{"type":"function","title":"Igniter.Test.puts_diff/2","doc":"Print the current `igniter` diff, returning the `igniter`.\n\nThis is primarily used for debugging purposes.","ref":"Igniter.Test.html#puts_diff/2"},{"type":"function","title":"Options - Igniter.Test.puts_diff/2","doc":"* `:label` - A label to print before the diff\n* `:only` - Only print the diff for this file or files","ref":"Igniter.Test.html#puts_diff/2-options"},{"type":"function","title":"Igniter.Test.test_project/1","doc":"Sets up a test igniter that has  only the files passed to it.","ref":"Igniter.Test.html#test_project/1"},{"type":"function","title":"Starting point - Igniter.Test.test_project/1","doc":"All of the files of an empty mix project are added by default.\nYou can specify more or overwrite files with the `:files` option.","ref":"Igniter.Test.html#test_project/1-starting-point"},{"type":"function","title":"Limitations - Igniter.Test.test_project/1","doc":"You cannot install new dependencies, or use dependencies your own project does not have.\nIf you need to do that kind of thing, you will have to do a test that uses tools like\n`System.cmd` in a temporary directory.","ref":"Igniter.Test.html#test_project/1-limitations"},{"type":"function","title":"Options - Igniter.Test.test_project/1","doc":"* `files` - A map of file paths to file contents. The file paths should be relative to the project root.\n* `app_name` - The name of the application. Defaults to `:test`.","ref":"Igniter.Test.html#test_project/1-options"},{"type":"function","title":"Examples - Igniter.Test.test_project/1","doc":"test_project(files: %{\n      \"lib/foo.ex\" => \"\"\"\n      defmodule MyApp.Foo do\n        use Ash.Resource\n      end\n      \"\"\"\n    })","ref":"Igniter.Test.html#test_project/1-examples"},{"type":"module","title":"Igniter.Upgrades","doc":"Utilities for running upgrades.","ref":"Igniter.Upgrades.html"},{"type":"function","title":"Igniter.Upgrades.run/5","doc":"Run all upgrades from `from` to `to`.","ref":"Igniter.Upgrades.html#run/5"},{"type":"task","title":"mix igniter.add_extension","doc":"Adds an extension to your `.igniter.exs` configuration file.\n\nThe extension can be the module name of an extension,\nor the string `phoenix`, which maps to `Igniter.Extensions.Phoenix`.","ref":"Mix.Tasks.Igniter.AddExtension.html"},{"type":"task","title":"Example - mix igniter.add_extension","doc":"```bash\nmix igniter.add_extension phoenix\n```","ref":"Mix.Tasks.Igniter.AddExtension.html#module-example"},{"type":"function","title":"Mix.Tasks.Igniter.AddExtension.igniter/1","doc":"","ref":"Mix.Tasks.Igniter.AddExtension.html#igniter/1"},{"type":"task","title":"mix igniter.apply_upgrades","doc":"Applies the upgrade scripts for the list of package version changes provided.\n\nThis can be used to explicitly run specific upgrade scripts within a given version range for a package.\nThis is also *required* if your call to `mix igniter.upgrade` requires an upgrade of igniter itself.\n\n```bash\nmix igniter.apply_upgrades package1:0.3.1:0.3.2 package2:1.2.4:1.5.9\n```","ref":"Mix.Tasks.Igniter.ApplyUpgrades.html"},{"type":"task","title":"Options - mix igniter.apply_upgrades","doc":"* `--yes` or `-y` - Accept all changes automatically","ref":"Mix.Tasks.Igniter.ApplyUpgrades.html#module-options"},{"type":"function","title":"Mix.Tasks.Igniter.ApplyUpgrades.igniter/1","doc":"","ref":"Mix.Tasks.Igniter.ApplyUpgrades.html#igniter/1"},{"type":"task","title":"mix igniter.gen.task","doc":"Generates a new igniter task","ref":"Mix.Tasks.Igniter.Gen.Task.html"},{"type":"task","title":"Example - mix igniter.gen.task","doc":"```bash\nmix igniter.gen.task my_app.install\n```","ref":"Mix.Tasks.Igniter.Gen.Task.html#module-example"},{"type":"task","title":"Options - mix igniter.gen.task","doc":"* `--no-optional` or `-o` - Whether or not to define the task to be compatible with igniter as an optional dependency.\n* `--upgrade` or `-u` - Whether or not the task is an upgrade task. See the upgrades guide for more.\n* `--private` or `-p` - Whether or not the task is a private task. This means it has no shortdoc or moduledoc.\n  Upgrade tasks are always private.","ref":"Mix.Tasks.Igniter.Gen.Task.html#module-options"},{"type":"function","title":"Mix.Tasks.Igniter.Gen.Task.igniter/1","doc":"","ref":"Mix.Tasks.Igniter.Gen.Task.html#igniter/1"},{"type":"task","title":"mix igniter.install","doc":"Install a package or packages, and run any associated installers.","ref":"Mix.Tasks.Igniter.Install.html"},{"type":"task","title":"Args - mix igniter.install","doc":"mix igniter.install package1 package2 package3","ref":"Mix.Tasks.Igniter.Install.html#module-args"},{"type":"task","title":"Package formats - mix igniter.install","doc":"* `package` - The latest version of the package will be installed, pinned at the\n   major version, or minor version if there is no major version yet.\n* `package@version` - The package will be installed at the specified version.\n   If the version given is generic, like `3.0`, it will be pinned as described above.\n   if it is specific, like `3.0.1`, it will be pinned at that *exact* version with `==`.\n* `package@git:git_url` - The package will be installed from the specified git url.\n* `package@github:project/repo` - The package will be installed from the specified github repo.\n* `package@path:path/to/dep` - The package will be installed from the specified path.\n\nAdditionally, a Git ref can be specified when using `git` or `github`:\n\n* `package@git:git_url@ref`","ref":"Mix.Tasks.Igniter.Install.html#module-package-formats"},{"type":"task","title":"Switches - mix igniter.install","doc":"* `--dry-run` - Run the task without making any changes.\n* `--yes` - Automatically answer yes to any prompts.\n* `--yes-to-deps` - Automatically answer yes to any prompts about installing new deps.\n* `--verbose` - Display additional output from various operations.\n* `--example` - Request that installed packages include initial example code.","ref":"Mix.Tasks.Igniter.Install.html#module-switches"},{"type":"task","title":"mix igniter.move_files","doc":"Moves any relavant files to their 'correct' location.","ref":"Mix.Tasks.Igniter.MoveFiles.html"},{"type":"function","title":"Mix.Tasks.Igniter.MoveFiles.igniter/1","doc":"","ref":"Mix.Tasks.Igniter.MoveFiles.html#igniter/1"},{"type":"task","title":"mix igniter.phx.install","doc":"Creates a new Phoenix project in the current application.","ref":"Mix.Tasks.Igniter.Phx.Install.html"},{"type":"task","title":"Example - mix igniter.phx.install","doc":"```bash\nmix igniter.phx.install . --module MyApp --app my_app\n```","ref":"Mix.Tasks.Igniter.Phx.Install.html#module-example"},{"type":"task","title":"Options - mix igniter.phx.install","doc":"* `--app` - the name of the OTP application\n\n  * `--module` - the name of the base module in\n    the generated skeleton\n\n  * `--database` - specify the database adapter for Ecto. One of:\n\n      * `postgres` - via https://github.com/elixir-ecto/postgrex\n      * `mysql` - via https://github.com/elixir-ecto/myxql\n      * `mssql` - via https://github.com/livehelpnow/tds\n      * `sqlite3` - via https://github.com/elixir-sqlite/ecto_sqlite3\n\n    Please check the driver docs for more information\n    and requirements. Defaults to \"postgres\".\n\n  * `--adapter` - specify the http adapter. One of:\n      * `cowboy` - via https://github.com/elixir-plug/plug_cowboy\n      * `bandit` - via https://github.com/mtrudel/bandit\n\n    Please check the adapter docs for more information\n    and requirements. Defaults to \"bandit\".\n\n  * `--no-assets` - equivalent to `--no-esbuild` and `--no-tailwind`\n\n  * `--no-dashboard` - do not include Phoenix.LiveDashboard\n\n  * `--no-ecto` - do not generate Ecto files\n\n  * `--no-esbuild` - do not include esbuild dependencies and assets.\n    We do not recommend setting this option, unless for API only\n    applications, as doing so requires you to manually add and\n    track JavaScript dependencies\n\n  * `--no-gettext` - do not generate gettext files\n\n  * `--no-html` - do not generate HTML views\n\n  * `--no-live` - comment out LiveView socket setup in your Endpoint\n    and assets/js/app.js. Automatically disabled if --no-html is given\n\n  * `--no-mailer` - do not generate Swoosh mailer files\n\n  * `--no-tailwind` - do not include tailwind dependencies and assets.\n    The generated markup will still include Tailwind CSS classes, those\n    are left-in as reference for the subsequent styling of your layout\n    and components\n\n  * `--binary-id` - use `binary_id` as primary key type in Ecto schemas\n\n  * `--verbose` - use verbose output\n\nWhen passing the `--no-ecto` flag, Phoenix generators such as\n`phx.gen.html`, `phx.gen.json`, `phx.gen.live`, and `phx.gen.context`\nmay no longer work as expected as they generate context files that rely\non Ecto for the database access. In those cases, you can pass the\n`--no-context` flag to generate most of the HTML and JSON files\nbut skip the context, allowing you to fill in the blanks as desired.\n\nSimilarly, if `--no-html` is given, the files generated by\n`phx.gen.html` will no longer work, as important HTML components\nwill be missing.","ref":"Mix.Tasks.Igniter.Phx.Install.html#module-options"},{"type":"function","title":"Mix.Tasks.Igniter.Phx.Install.igniter/1","doc":"","ref":"Mix.Tasks.Igniter.Phx.Install.html#igniter/1"},{"type":"task","title":"mix igniter.refactor.rename_function","doc":"A short description of your task\n\nRename a given function across a whole project.\nThis will remap definitions in addition to calls and references.\n\nKeep in mind that it cannot detect 100% of cases, and will always\nmiss usage of `apply/3` for dynamic function calling.\n\nIf the new module is different than the old module, the function will be moved.\nIf the new module does not exist, it will be created.\n\nPass an arity to the first function to only rename a specific arity definition.","ref":"Mix.Tasks.Igniter.Refactor.RenameFunction.html"},{"type":"task","title":"Options - mix igniter.refactor.rename_function","doc":"- `--deprecate` - `soft | hard` The old function will remain in place but deprecated. Soft deprecations,\n  only affect documentation, while hard deprecations will display a warning when the function is called.","ref":"Mix.Tasks.Igniter.Refactor.RenameFunction.html#module-options"},{"type":"task","title":"Example - mix igniter.refactor.rename_function","doc":"```bash\nmix igniter.refactor.rename_function Mod.fun NewMod.new_fun\n```","ref":"Mix.Tasks.Igniter.Refactor.RenameFunction.html#module-example"},{"type":"function","title":"Mix.Tasks.Igniter.Refactor.RenameFunction.igniter/1","doc":"","ref":"Mix.Tasks.Igniter.Refactor.RenameFunction.html#igniter/1"},{"type":"function","title":"Mix.Tasks.Igniter.Refactor.RenameFunction.parse_fun/1","doc":"","ref":"Mix.Tasks.Igniter.Refactor.RenameFunction.html#parse_fun/1"},{"type":"task","title":"mix igniter.refactor.unless_to_if_not","doc":"Rewrites occurences of `unless x` to `if !x` across the project.","ref":"Mix.Tasks.Igniter.Refactor.UnlessToIfNot.html"},{"type":"task","title":"Example - mix igniter.refactor.unless_to_if_not","doc":"```bash\nmix igniter.refactor.unless_to_if_not\n```","ref":"Mix.Tasks.Igniter.Refactor.UnlessToIfNot.html#module-example"},{"type":"function","title":"Mix.Tasks.Igniter.Refactor.UnlessToIfNot.igniter/1","doc":"","ref":"Mix.Tasks.Igniter.Refactor.UnlessToIfNot.html#igniter/1"},{"type":"task","title":"mix igniter.setup","doc":"Creates or updates a .igniter.exs file, used to configure Igniter for end user's preferences.","ref":"Mix.Tasks.Igniter.Setup.html"},{"type":"function","title":"Mix.Tasks.Igniter.Setup.igniter/1","doc":"","ref":"Mix.Tasks.Igniter.Setup.html#igniter/1"},{"type":"task","title":"mix igniter.update_gettext","doc":"Applies changes to resolve a warning introduced in gettext 0.26.0","ref":"Mix.Tasks.Igniter.UpdateGettext.html"},{"type":"function","title":"Mix.Tasks.Igniter.UpdateGettext.igniter/1","doc":"","ref":"Mix.Tasks.Igniter.UpdateGettext.html#igniter/1"},{"type":"task","title":"mix igniter.upgrade","doc":"Fetch and upgrade dependencies. A drop in replacement for `mix deps.update` that also runs upgrade tasks.\n\nUpdates dependencies via `mix deps.update` and then runs any upgrade tasks for any changed dependencies.\n\nBy default, this task updates to the latest versions allowed by the `mix.exs` file, just like `mix deps.update`.\n\nTo upgrade a package to a specific version, you can specify the version after the package name,\nseparated by an `@` symbol. This allows upgrading beyond what your mix.exs file currently specifies,\ni.e if you have `~> 1.0` in your mix.exs file, you can use `mix igniter.upgrade package@2.0` to\nupgrade to version 2.0, which will update your `mix.exs` and run any equivalent upgraders.","ref":"Mix.Tasks.Igniter.Upgrade.html"},{"type":"task","title":"Limitations - mix igniter.upgrade","doc":"The new version of the package must be \"compile compatible\" with your existing code. See the upgrades guide for more.","ref":"Mix.Tasks.Igniter.Upgrade.html#module-limitations"},{"type":"task","title":"Example - mix igniter.upgrade","doc":"```bash\nmix igniter.upgrade package1 package2@1.2.1\n```","ref":"Mix.Tasks.Igniter.Upgrade.html#module-example"},{"type":"task","title":"Options - mix igniter.upgrade","doc":"* `--yes` - Accept all changes automatically\n* `--all` - Upgrades all dependencies\n* `--only` - only fetches dependencies for given environment\n* `--verbose` - display additional output from various operations\n* `--target` - only fetches dependencies for given target\n* `--no-archives-check` - does not check archives before fetching deps\n* `--git-ci` - Uses git history (HEAD~1) to check the previous versions in the lock file.\n  See the upgrade guides for more. Sets --yes automatically.","ref":"Mix.Tasks.Igniter.Upgrade.html#module-options"},{"type":"function","title":"Mix.Tasks.Igniter.Upgrade.igniter/1","doc":"","ref":"Mix.Tasks.Igniter.Upgrade.html#igniter/1"},{"type":"behaviour","title":"Igniter.Mix.Task","doc":"A behaviour for implementing a Mix task that is enriched to be composable with other Igniter tasks.\n\n>","ref":"Igniter.Mix.Task.html"},{"type":"behaviour","title":"Note {: .info} - Igniter.Mix.Task","doc":">\n> A default `run/1` is implemented so you can directly run the task. Igniter never uses this function, so it is overridable.\n>\n> This enables your library to make use of the task for its own purposes if needed. An example would be if you wanted to implement an Igniter installer, but also have an `install` task for end-user consumption (e.g. `mix tailwind.install`).","ref":"Igniter.Mix.Task.html#module-note-info"},{"type":"behaviour","title":"Options and Arguments - Igniter.Mix.Task","doc":"Command line args are automatically parsed into `igniter.args` using the configuration returned\nfrom `c:info/2`. See `Igniter.Mix.Task.Info` for more.","ref":"Igniter.Mix.Task.html#module-options-and-arguments"},{"type":"callback","title":"Igniter.Mix.Task.igniter/1","doc":"Main entrypoint for tasks. This callback accepts and returns an `Igniter` struct.","ref":"Igniter.Mix.Task.html#c:igniter/1"},{"type":"callback","title":"Igniter.Mix.Task.igniter/2","doc":"All the generator behavior happens here, you take an igniter and task arguments, and return an igniter.","ref":"Igniter.Mix.Task.html#c:igniter/2"},{"type":"callback","title":"Igniter.Mix.Task.info/2","doc":"Returns an `Igniter.Mix.Task.Info` struct, with information used when running the igniter task.\n\nThis info will be used to validate arguments in composed tasks.\n\nUse the `positional_args!(argv)` to get your positional arguments according to your `info.positional`, and the remaining unused args.\nUse the `options!(argv)` macro to get your parsed options according to your `info.schema`.","ref":"Igniter.Mix.Task.html#c:info/2"},{"type":"callback","title":"Important Limitations - Igniter.Mix.Task.info/2","doc":"* Each task still must parse its own argv in `igniter/2` and *must* ignore any unknown options.\n  To accomplish this, use the automatically imported `options!(argv)` macro, which uses the `info/2`\n  callback to validate args and return options\n* You cannot use `composes` to list tasks unless they are in your library or in direct dependencies of your library.\n  To validate their options, you must include their options in your own option schema.","ref":"Igniter.Mix.Task.html#c:info/2-important-limitations"},{"type":"callback","title":"Igniter.Mix.Task.installer?/0","doc":"","ref":"Igniter.Mix.Task.html#c:installer?/0"},{"type":"macro","title":"Igniter.Mix.Task.options!/1","doc":"Parses the options for the task based on its info.","ref":"Igniter.Mix.Task.html#options!/1"},{"type":"callback","title":"Igniter.Mix.Task.parse_argv/1","doc":"Returns an `Igniter.Mix.Task.Args` struct.\n\nThis callback can be implemented to private custom parsing and validation behavior for\ncommand line arguments. By default, the options specified in `c:info/2` will be used\nto inject a default implementation.","ref":"Igniter.Mix.Task.html#c:parse_argv/1"},{"type":"macro","title":"Igniter.Mix.Task.positional_args!/1","doc":"","ref":"Igniter.Mix.Task.html#positional_args!/1"},{"type":"callback","title":"Igniter.Mix.Task.supports_umbrella?/0","doc":"Whether or not it supports being run in the root of an umbrella project\n\nAt the moment, this is still experimental and we suggest not turning it on.","ref":"Igniter.Mix.Task.html#c:supports_umbrella?/0"},{"type":"module","title":"Igniter.Mix.Task.Args","doc":"Command line arguments parsed when running an `Igniter.Mix.Task`.\n\nThese args will usually be accessed through `igniter.args` when the\n`c:Igniter.Mix.Task.igniter/1` callback is run. To learn more about how\nthey are parsed, see `Igniter.Mix.Task.Info`.","ref":"Igniter.Mix.Task.Args.html"},{"type":"type","title":"Igniter.Mix.Task.Args.t/0","doc":"","ref":"Igniter.Mix.Task.Args.html#t:t/0"},{"type":"module","title":"Igniter.Mix.Task.Info","doc":"Info for an `Igniter.Mix.Task`, returned from the `info/2` callback","ref":"Igniter.Mix.Task.Info.html"},{"type":"module","title":"Configurable Keys - Igniter.Mix.Task.Info","doc":"* `schema` - The option schema for this task, in the format given to `OptionParser`, i.e `[name: :string]`. See the schema section for more.\n* `defaults` - Default values for options in the schema.\n* `required` - A list of flags that are required for this task to run.\n* `positional` - A list of positional arguments that this task accepts. A list of atoms, or a keyword list with the option and config.\n  See the positional arguments section for more.\n* `aliases` - A map of aliases to the schema keys.\n* `composes` - A list of tasks that this task might compose.\n* `installs` - A list of dependencies that should be installed before continuing.\n* `adds_deps` - A list of dependencies that should be added to the `mix.exs`, but do not need to be installed before continuing.\n* `extra_args?` - Whether or not to allow extra arguments. This forces all tasks that compose this task to allow extra args as well.\n* `example` - An example usage of the task. This is used in the help output.\n\nYour task should *always* use `switches` and not `strict` to validate provided options!","ref":"Igniter.Mix.Task.Info.html#module-configurable-keys"},{"type":"module","title":"Options and Arguments - Igniter.Mix.Task.Info","doc":"Command line args are automatically parsed into `igniter.args` using this struct's configuration.\n\n    @impl Igniter.Mix.Task\n    def igniter(igniter) do\n      positional = igniter.args.positional\n      options = igniter.args.options\n    end\n\nIf you need to do custom validation or parsing, you can implement `c:Igniter.Mix.Task.parse_argv/1`\nand return an `Igniter.Mix.Task.Args` struct. If helpful, the `positional_args!/1` and\n`options!/1` macros can be used to parse positional arguments and options/flags using your\ninfo configuration.\n\n    @impl Igniter.Mix.Task\n    def parse_argv(argv) do\n      {positional, argv_flags} = positional_args!(argv)\n      options = options!(argv_flags)\n\n      # custom validation or additional parsing\n\n      %Igniter.Mix.Task.Args{\n        argv: argv,\n        argv_flags: argv_flags,\n        positional: positional,\n        options: options\n      }\n    end","ref":"Igniter.Mix.Task.Info.html#module-options-and-arguments"},{"type":"module","title":"Options - Igniter.Mix.Task.Info","doc":"The schema is an option parser schema, and `OptionParser` is used to parse the options, with\na few noteable differences.\n\n- The defaults from the `defaults` option in your task info are applied.\n- The `:keep` type is automatically aggregated into a list.\n- The `:csv` option automatically splits the value on commas, and allows it to be specified multiple times.","ref":"Igniter.Mix.Task.Info.html#module-options"},{"type":"module","title":"Positional Arguments - Igniter.Mix.Task.Info","doc":"Each positional argument can provide the following options:\n\n* `:optional` - Whether or not the argument is optional. Defaults to `false`.\n* `:rest` - Whether or not the argument consumes the rest of the positional arguments. Defaults to `false`.\n            The value will be converted to a list automatically.","ref":"Igniter.Mix.Task.Info.html#module-positional-arguments"},{"type":"function","title":"Igniter.Mix.Task.Info.global_options/0","doc":"","ref":"Igniter.Mix.Task.Info.html#global_options/0"},{"type":"type","title":"Igniter.Mix.Task.Info.t/0","doc":"","ref":"Igniter.Mix.Task.Info.html#t:t/0"},{"type":"module","title":"Igniter.Project.Application","doc":"Codemods and tools for working with Application modules.","ref":"Igniter.Project.Application.html"},{"type":"function","title":"Igniter.Project.Application.add_new_child/3","doc":"Adds a new child to the `children` list in the application file\n\nTo pass quoted code as the options, use the following format:\n\n    {module, {:code, quoted_code}}\n\ni.e\n\n    {MyApp.Supervisor, {:code, quote do\n      Application.fetch_env!(:app, :config)\n    end}}","ref":"Igniter.Project.Application.html#add_new_child/3"},{"type":"function","title":"Options - Igniter.Project.Application.add_new_child/3","doc":"- `:after` - A list of other modules that this supervisor should appear after,\n   or a function that takes a module and returns `true` if this module should be placed after it.\n- `:opts_updater` - A function that takes the current options (second element of the child tuple),\n   and returns a new value. If the existing value of the module is not a tuple, the value passed into\n   your function will be `[]`. Your function *must* return `{:ok, zipper}` or\n   `{:error | :warning, \"error_or_warning\"}`.\n- `:force?` - If `true`, forces adding a new child, even if an existing child uses the\n  same child module. Defaults to `false`.","ref":"Igniter.Project.Application.html#add_new_child/3-options"},{"type":"function","title":"Ordering - Igniter.Project.Application.add_new_child/3","doc":"We will put the new child as the earliest item in the list that we can, skipping any modules\nin the `after` option.","ref":"Igniter.Project.Application.html#add_new_child/3-ordering"},{"type":"function","title":"Examples - Igniter.Project.Application.add_new_child/3","doc":"Given an application `start/2` that looks like this:\n\n    def start(_type, _args) do\n      children = [\n        ChildOne,\n        {ChildTwo, opt: 1}\n      ]\n\n      Supervisor.start_link(children, strategy: :one_for_one)\n    end\n\nAdd a new child that isn't currently present:\n\n    Igniter.Project.Application.add_new_child(igniter, NewChild)\n    # =>\n    children = [\n      NewChild,\n      ChildOne,\n      {ChildTwo, opt: 1}\n    ]\n\nAdd a new child after some existing ones:\n\n    Igniter.Project.Application.add_new_child(igniter, NewChild, after: [ChildOne, ChildTwo])\n    # =>\n    children = [\n      ChildOne,\n      {ChildTwo, opt: 1},\n      NewChild\n    ]\n\nIf the given child module is already present, `add_new_child/3` is a no-op by default:\n\n    Igniter.Project.Application.add_new_child(igniter, {ChildOne, opt: 1})\n    # =>\n    children = [\n      ChildOne,\n      {ChildTwo, opt: 1}\n    ]\n\nYou can explicitly handle module conflicts by passing an `:opts_updater`:\n\n    Igniter.Project.Application.add_new_child(igniter, {ChildOne, opt: 1},\n      opts_updater: fn opts ->\n        {:ok, Sourceror.Zipper.replace(opts, [opt: 1])}\n      end\n    )\n    # =>\n    children = [\n      {ChildOne, opt: 1},\n      {ChildTwo, opt: 1}\n    ]\n\nUsing `force?: true`, you can force a child to be added, even if the module\nconflicts with an existing one:\n\n    Igniter.Project.Application.add_new_child(igniter, {ChildOne, opt: 1}, force?: true)\n    # =>\n    children = [\n      {ChildOne, opt: 1},\n      ChildOne,\n      {ChildTwo, opt: 1}\n    ]","ref":"Igniter.Project.Application.html#add_new_child/3-examples"},{"type":"function","title":"Igniter.Project.Application.app_module/1","doc":"Returns the name of the application module.","ref":"Igniter.Project.Application.html#app_module/1"},{"type":"function","title":"Igniter.Project.Application.app_name/0","doc":"Returns the name of the current application.","ref":"Igniter.Project.Application.html#app_name/0"},{"type":"function","title":"Igniter.Project.Application.app_name/1","doc":"Returns the name of the application.","ref":"Igniter.Project.Application.html#app_name/1"},{"type":"function","title":"Igniter.Project.Application.create_app/2","doc":"","ref":"Igniter.Project.Application.html#create_app/2"},{"type":"function","title":"Igniter.Project.Application.create_application_file/2","doc":"","ref":"Igniter.Project.Application.html#create_application_file/2"},{"type":"function","title":"Igniter.Project.Application.priv_dir/2","doc":"Returns the path of the application's priv directory.","ref":"Igniter.Project.Application.html#priv_dir/2"},{"type":"function","title":"Igniter.Project.Application.skip_after/2","doc":"","ref":"Igniter.Project.Application.html#skip_after/2"},{"type":"module","title":"Igniter.Project.Config","doc":"Codemods and utilities for modifying Elixir config files.","ref":"Igniter.Project.Config.html"},{"type":"function","title":"Igniter.Project.Config.configure/6","doc":"Sets a config value in the given configuration file, updating it with `updater` if it is already set.\n\nIf the value is source code, pass `{:code, value}`, otherwise pass just the value.\n\nTo produce this source code, we suggest using `Sourceror.parse_string!`. For example:\n\n```elixir\n|> Igniter.Project.Config.configure(\n  \"fake.exs\",\n  :tailwind,\n  [:default, :args],\n  {:code,\n   Sourceror.parse_string!(\"\"\"\n   ~w(--config=tailwind.config.js --input=css/app.css --output=../output/assets/app.css)\n   \"\"\")}\n)\n```","ref":"Igniter.Project.Config.html#configure/6"},{"type":"function","title":"Opts - Igniter.Project.Config.configure/6","doc":"* `:updater` - A function that takes a zipper at a currently configured value and returns a new zipper with the value updated.\n* `failure_message` - A message to display to the user if the configuration change is unsuccessful.","ref":"Igniter.Project.Config.html#configure/6-opts"},{"type":"function","title":"Igniter.Project.Config.configure_new/6","doc":"Sets a config value in the given configuration file, if it is not already set.\n\nSee `configure/6` for more.","ref":"Igniter.Project.Config.html#configure_new/6"},{"type":"function","title":"Opts - Igniter.Project.Config.configure_new/6","doc":"* `failure_message` - A message to display to the user if the configuration change is unsuccessful.","ref":"Igniter.Project.Config.html#configure_new/6-opts"},{"type":"function","title":"Igniter.Project.Config.configure_runtime_env/6","doc":"","ref":"Igniter.Project.Config.html#configure_runtime_env/6"},{"type":"function","title":"Igniter.Project.Config.configures?/3","doc":"","ref":"Igniter.Project.Config.html#configures?/3"},{"type":"function","title":"Igniter.Project.Config.configures?/4","doc":"Returns `true` if the given configuration path is set somewhere after the provided zipper, or in the given configuration file.","ref":"Igniter.Project.Config.html#configures?/4"},{"type":"function","title":"Igniter.Project.Config.configures_key?/3","doc":"Same as `configures_key?/4` but accepts a Zipper.","ref":"Igniter.Project.Config.html#configures_key?/3"},{"type":"function","title":"Igniter.Project.Config.configures_key?/4","doc":"If the last argument is key, checks if either `config :root_key, :key, ...`\nor `config :root_key, key: ...` is set.\n\nIf the last argument is a keyword path, checks if\n`config :root_key, path_head, [...]` defines `path_rest` or if\n`config :root_key, [...]` defines `path`, where `path_head` is the first\nelement of `path` and `path_rest` are the remaining elements.\n\nNote: `config_file_name` should _not_ include the `config/` prefix.","ref":"Igniter.Project.Config.html#configures_key?/4"},{"type":"function","title":"Igniter.Project.Config.configures_root_key?/2","doc":"Same as `configures_root_key?/3` but accepts a Zipper instead.","ref":"Igniter.Project.Config.html#configures_root_key?/2"},{"type":"function","title":"Igniter.Project.Config.configures_root_key?/3","doc":"Checks if either `config :root_key, _` or `config :root_key, _, _` is present\nin the provided config file.\n\nNote: The config file name should _not_ include the `config/` prefix.","ref":"Igniter.Project.Config.html#configures_root_key?/3"},{"type":"function","title":"Igniter.Project.Config.modify_configuration_code/5","doc":"Modifies elixir configuration code starting at the configured zipper.\n\nIf you want to set configuration, use `configure/6` or `configure_new/5` instead. This is a lower-level\ntool for modifying configuration files when you need to adjust some specific part of them.","ref":"Igniter.Project.Config.html#modify_configuration_code/5"},{"type":"module","title":"Igniter.Project.Deps","doc":"Codemods and utilities for managing dependencies declared in mix.exs","ref":"Igniter.Project.Deps.html"},{"type":"function","title":"Igniter.Project.Deps.add_dep/3","doc":"Adds a dependency to the mix.exs file.\n\n```elixir\n|> Igniter.Project.Deps.add_dep({:my_dependency, \"~> X.Y.Z\"})\n```\n\n# Options\n\n- `:yes?` - Automatically answer yes to any prompts.\n- `:append?` - Append to the dependency list instead of prepending.\n- `:error?` - Returns an error instead of a notice on failure.","ref":"Igniter.Project.Deps.html#add_dep/3"},{"type":"function","title":"Igniter.Project.Deps.add_dependency/4","doc":"","ref":"Igniter.Project.Deps.html#add_dependency/4"},{"type":"function","title":"Igniter.Project.Deps.get_dependency_declaration/2","doc":"Gets the current dependency declaration in mix.exs for a given dependency.","ref":"Igniter.Project.Deps.html#get_dependency_declaration/2"},{"type":"function","title":"Igniter.Project.Deps.has_dep?/2","doc":"Returns true if the given dependency is in `mix.exs`","ref":"Igniter.Project.Deps.html#has_dep?/2"},{"type":"function","title":"Igniter.Project.Deps.remove_dep/2","doc":"Removes a dependency from mix.exs","ref":"Igniter.Project.Deps.html#remove_dep/2"},{"type":"function","title":"Igniter.Project.Deps.set_dep_option/4","doc":"Sets a dependency option for an existing dependency","ref":"Igniter.Project.Deps.html#set_dep_option/4"},{"type":"module","title":"Igniter.Project.Formatter","doc":"Codemods and utilities for interacting with `.formatter.exs` files","ref":"Igniter.Project.Formatter.html"},{"type":"function","title":"Igniter.Project.Formatter.add_formatter_plugin/2","doc":"Adds a new plugin to the list of plugins in the root `.formatter.exs`","ref":"Igniter.Project.Formatter.html#add_formatter_plugin/2"},{"type":"function","title":"Igniter.Project.Formatter.import_dep/2","doc":"Adds a new dep to the list of imported deps in the root `.formatter.exs`","ref":"Igniter.Project.Formatter.html#import_dep/2"},{"type":"function","title":"Igniter.Project.Formatter.remove_formatter_plugin/2","doc":"REmoves a plugin to the list of plugins in the root `.formatter.exs`","ref":"Igniter.Project.Formatter.html#remove_formatter_plugin/2"},{"type":"function","title":"Igniter.Project.Formatter.remove_imported_dep/2","doc":"Removes an imported dep from the list of imported deps in the root `.formatter.exs`","ref":"Igniter.Project.Formatter.html#remove_imported_dep/2"},{"type":"module","title":"Igniter.Project.IgniterConfig","doc":"Tools for reading and modifying the `.igniter.exs` file.\n\nThe command `mix igniter.setup` will generate this file, as well\nas keep it up to date with any new configurations. You can run this\ncommand at any time to update the file without overriding your own config.\n\nIf the file does not exist, all values are considered to have their default value.","ref":"Igniter.Project.IgniterConfig.html"},{"type":"module","title":"Options - Igniter.Project.IgniterConfig","doc":"- `module_location` - \n  - `:outside_matching_folder`, modules will be placed in a folder exactly matching their path.\n  - `:inside_matching_folder`, modules who's name matches an existing folder will be placed inside that folder,\n    or moved there if the folder is created.\n\n- `extensions` - \nA list of extensions to use in the project.\n- `source_folders` - \nA list of folders to manage elixir files in.\n- `dont_move_files` - \nA list of strings or regexes. Any files that equal (in the case of strings) or match (in the case of regexes) will not be moved.","ref":"Igniter.Project.IgniterConfig.html#module-options"},{"type":"function","title":"Igniter.Project.IgniterConfig.add_extension/2","doc":"","ref":"Igniter.Project.IgniterConfig.html#add_extension/2"},{"type":"function","title":"Igniter.Project.IgniterConfig.dont_move_file_pattern/2","doc":"","ref":"Igniter.Project.IgniterConfig.html#dont_move_file_pattern/2"},{"type":"function","title":"Igniter.Project.IgniterConfig.get/2","doc":"","ref":"Igniter.Project.IgniterConfig.html#get/2"},{"type":"function","title":"Igniter.Project.IgniterConfig.setup/1","doc":"","ref":"Igniter.Project.IgniterConfig.html#setup/1"},{"type":"module","title":"Igniter.Project.MixProject","doc":"Codemods and utilities for updating project configuration in mix.exs.","ref":"Igniter.Project.MixProject.html"},{"type":"function","title":"Igniter.Project.MixProject.update/4","doc":"Updates the project configuration AST at the given path.\n\nThis function accepts a `function_name` atom corresponding to a function\nlike `project/0`, `application/0`, or `cli/0` and navigates to the given\npath, jumping to private functions if necessary and creating nested\nkeyword lists if they don't already exist. It then calls the given\n`update_fun`, using the return value to update the AST.\n\n`update_fun` must be a function that accepts one argument, a zipper\ntargeting the current AST at the given configuration path or `nil` if\nthere was no value at that path. It then must return one of the\nfollowing:\n\n  * `{:ok, zipper}` - the updated zipper\n  * `{:ok, {:code, quoted}}` - a quoted expression that should be\n    inserted as the new value at `path`\n  * `{:ok, nil}` - indicates that the last key in `path` should be\n    removed\n  * `{:error, message}` or `{:warning, message}` - an error or warning\n    that should be added to `igniter`\n  * `:error` - indicates `igniter` should be returned without change","ref":"Igniter.Project.MixProject.html#update/4"},{"type":"function","title":"Examples - Igniter.Project.MixProject.update/4","doc":"Assuming a newly-generated Mix project that looks like:\n\n    defmodule Example.MixProject do\n      use Mix.Project\n\n      def project do\n        [\n          app: :example,\n          version: \"0.1.0\",\n          elixir: \"~> 1.17\",\n          start_permanent: Mix.env() == :prod,\n          deps: deps()\n        ]\n      end\n\n      def application do\n        [\n          extra_applications: [:logger]\n        ]\n      end\n\n      defp deps do\n        []\n      end\n    end","ref":"Igniter.Project.MixProject.html#update/4-examples"},{"type":"function","title":"Increment the project version by one patch level - Igniter.Project.MixProject.update/4","doc":"Igniter.Project.MixProject.update(igniter, :project, [:version], fn zipper ->\n      new_version =\n        zipper.node\n        |> Version.parse!()\n        |> Map.update!(:patch, &(&1 + 1))\n        |> to_string()\n\n      {:ok, {:code, new_version}}\n    end)\n\n    # would result in\n    def project do\n      [\n        ...,\n        version: \"0.1.1\",\n        ...\n      ]\n    end","ref":"Igniter.Project.MixProject.html#update/4-increment-the-project-version-by-one-patch-level"},{"type":"function","title":"Set the preferred env for a task to `:test` - Igniter.Project.MixProject.update/4","doc":"Igniter.Project.MixProject.update(\n      igniter,\n      :cli,\n      [:preferred_envs, :\"some.task\"],\n      fn _ -> {:ok, {:code, :test}} end\n    )\n\n    # would create `cli/0` and set the env:\n    def cli do\n      [\n        preferred_envs: [\n          \"some.task\": :test\n        ]\n      ]\n    end","ref":"Igniter.Project.MixProject.html#update/4-set-the-preferred-env-for-a-task-to-test"},{"type":"function","title":"Add `:some_application` to `:extra_applications` - Igniter.Project.MixProject.update/4","doc":"Igniter.Project.MixProject.update(igniter, :application, [:extra_applications], fn\n      nil -> {:ok, {:code, [:some_application]}}\n      zipper -> Igniter.Code.List.append_to_list(zipper, :some_application)\n    end)\n\n    # would result in\n    def application do\n      [\n        extra_applications: [:logger, :some_application]\n      ]\n    end","ref":"Igniter.Project.MixProject.html#update/4-add-some_application-to-extra_applications"},{"type":"function","title":"Remove `:extra_applications` altogether - Igniter.Project.MixProject.update/4","doc":"Igniter.Project.MixProject.update(\n      igniter,\n      :application,\n      [:extra_applications],\n      fn _ -> {:ok, nil} end\n    )\n\n    # would result in\n    def application do\n      []\n    end","ref":"Igniter.Project.MixProject.html#update/4-remove-extra_applications-altogether"},{"type":"module","title":"Igniter.Project.Module","doc":"Codemods and utilities for interacting with modules","ref":"Igniter.Project.Module.html"},{"type":"function","title":"Igniter.Project.Module.create_module/4","doc":"Creates a new file & module in its appropriate location.","ref":"Igniter.Project.Module.html#create_module/4"},{"type":"function","title":"Options - Igniter.Project.Module.create_module/4","doc":"- `:location` - A location type. See `t:location_type` for more.","ref":"Igniter.Project.Module.html#create_module/4-options"},{"type":"function","title":"Igniter.Project.Module.find_all_matching_modules/2","doc":"","ref":"Igniter.Project.Module.html#find_all_matching_modules/2"},{"type":"function","title":"Igniter.Project.Module.find_and_update_module/3","doc":"Finds a module and updates its contents. Returns `{:error, igniter}` if the module could not be found. Do not discard this igniter.","ref":"Igniter.Project.Module.html#find_and_update_module/3"},{"type":"function","title":"Igniter.Project.Module.find_and_update_module!/3","doc":"Finds a module and updates its contents. Raises an error if it doesn't exist","ref":"Igniter.Project.Module.html#find_and_update_module!/3"},{"type":"function","title":"Igniter.Project.Module.find_and_update_or_create_module/5","doc":"Finds a module and updates its contents wherever it is.\n\nIf the module does not yet exist, it is created with the provided contents. In that case,\nthe path is determined with `Igniter.Code.Module.proper_location/2`, but may optionally be overwritten with options below.\n\n# Options\n\n- `:path` - Path where to create the module, relative to the project root. Default: `nil` (uses `:kind` to determine the path).","ref":"Igniter.Project.Module.html#find_and_update_or_create_module/5"},{"type":"function","title":"Igniter.Project.Module.find_module/2","doc":"Finds a module, returning a new igniter, and the source and zipper location. This new igniter should not be discarded.\n\nIn general, you should not use the returned source and zipper to update the module, instead, use this to interrogate\nthe contents or source in some way, and then call `find_and_update_module/3` with a function to perform an update.","ref":"Igniter.Project.Module.html#find_module/2"},{"type":"function","title":"Igniter.Project.Module.find_module!/2","doc":"Finds a module, raising an error if its not found.\n\nSee `find_module/2` for more information.","ref":"Igniter.Project.Module.html#find_module!/2"},{"type":"type","title":"Igniter.Project.Module.location_type/0","doc":"Placement instruction for a module.\n\n- `:source_folder` - The first source folder of the project\n- `{:source_folder, path}` - The selected source folder, i.e `\"lib\"`\n- `:test` - Creating a test file\n- `:test_support` - Creating a test support file","ref":"Igniter.Project.Module.html#t:location_type/0"},{"type":"function","title":"Igniter.Project.Module.module_exists/2","doc":"Checks if a module is defined somewhere in the project. The returned igniter should not be discarded.","ref":"Igniter.Project.Module.html#module_exists/2"},{"type":"function","title":"Igniter.Project.Module.module_exists?/2","doc":"Checks if a module is defined somewhere in the project. The returned igniter should not be discarded.","ref":"Igniter.Project.Module.html#module_exists?/2"},{"type":"function","title":"Igniter.Project.Module.module_name/2","doc":"Given a suffix, returns a module name with the prefix of the current project.","ref":"Igniter.Project.Module.html#module_name/2"},{"type":"function","title":"Igniter.Project.Module.module_name_prefix/1","doc":"The module name prefix based on the mix project's module name","ref":"Igniter.Project.Module.html#module_name_prefix/1"},{"type":"function","title":"Igniter.Project.Module.parse/1","doc":"Parses a string into a module name","ref":"Igniter.Project.Module.html#parse/1"},{"type":"function","title":"Igniter.Project.Module.proper_location/3","doc":"Determines where a module should be placed in a project.","ref":"Igniter.Project.Module.html#proper_location/3"},{"type":"module","title":"Igniter.Project.TaskAliases","doc":"Codemods and utilities for interacting with task aliases in the mix.exs file","ref":"Igniter.Project.TaskAliases.html"},{"type":"function","title":"Igniter.Project.TaskAliases.add_alias/4","doc":"Adds an alias to the mix.exs file\n\n# Options\n\n- `:if_exists` - How to alter the alias if it already exists. Options are:\n- `:ignore` - Do nothing if the alias already exists. This is the default.\n- `:prepend` - Add the new alias to the beginning of the list (if it is not already present).\n- `{:prepend, value}` - Add a different value than the originally supplied alias to the beginning of the list (if it is not already present).\n- `{:replace_or_append, old, new}` - If the old value is in the list, it is replaced with the new value. Otherwise the new value is appended (if it is not already present).\n- `:append` - Add the new alias to the end of the list (if it is not already present).\n- `{:append, value}` - Add a different value than the originally supplied alias to the end of the list (if it is not already present).\n- `:warn` - Print a warning if the alias already exists.","ref":"Igniter.Project.TaskAliases.html#add_alias/4"},{"type":"function","title":"Igniter.Project.TaskAliases.modify_existing_alias/3","doc":"Modifies an existing alias, doing nothing if it doesn't exist","ref":"Igniter.Project.TaskAliases.html#modify_existing_alias/3"},{"type":"module","title":"Igniter.Project.Test","doc":"Codemods and utilities for interacting with test and test support files","ref":"Igniter.Project.Test.html"},{"type":"function","title":"Igniter.Project.Test.ensure_test_support/1","doc":"","ref":"Igniter.Project.Test.html#ensure_test_support/1"},{"type":"module","title":"Igniter.Refactors.Elixir","doc":"Refactors for changes in Elixir","ref":"Igniter.Refactors.Elixir.html"},{"type":"function","title":"Igniter.Refactors.Elixir.unless_to_if_not/1","doc":"","ref":"Igniter.Refactors.Elixir.html#unless_to_if_not/1"},{"type":"module","title":"Igniter.Refactors.Rename","doc":"Refactors for renaming things in a project","ref":"Igniter.Refactors.Rename.html"},{"type":"function","title":"Igniter.Refactors.Rename.rename_function/4","doc":"Renames a function globally across a project.","ref":"Igniter.Refactors.Rename.html#rename_function/4"},{"type":"function","title":"Options - Igniter.Refactors.Rename.rename_function/4","doc":"- `:arity` - `:any` | integer | [integer]. The arity or arities of the function to rename. Defaults to `:any`.\n- `:deprecate` - `:soft | :hard`. Leave the original function in place, but with a deprecation.\n  Soft deprecations appear in documentation but do not cause warnings. Hard deprecations warn when they are called.","ref":"Igniter.Refactors.Rename.html#rename_function/4-options"},{"type":"function","title":"Igniter.Refactors.Rename.subsume_module_attrs/1","doc":"","ref":"Igniter.Refactors.Rename.html#subsume_module_attrs/1"},{"type":"module","title":"Igniter.Code.Common","doc":"General purpose utilities for working with `Sourceror.Zipper`.","ref":"Igniter.Code.Common.html"},{"type":"function","title":"Igniter.Code.Common.add_code/3","doc":"Adds the provided code to the zipper.","ref":"Igniter.Code.Common.html#add_code/3"},{"type":"function","title":"Options - Igniter.Code.Common.add_code/3","doc":"- `:placement` - `:after` | `:before`. Determines if the code goes `:after` or `:before` the current node. Defaults to `:after`.\n- `:expand_env?` - boolean. Whether or not to read the current file to use it's aliases for added code. Defaults to `false`.","ref":"Igniter.Code.Common.html#add_code/3-options"},{"type":"function","title":"Example: - Igniter.Code.Common.add_code/3","doc":"```elixir\nexisting_zipper = \"\"\"\nIO.inspect(\"Hello, world!\")\n\"\"\"\n|> Sourceror.parse_string!()\n|> Sourceror.Zipper.zip()\n\nnew_code = \"\"\"\nIO.inspect(\"Goodbye, world!\")\n\"\"\"\n\nexisting_zipper\n|> Igniter.Common.add_code(new_code)\n|> Sourceror.Zipper.root()\n|> Sourceror.to_string()\n```\n\nWhich will produce\n\n```elixir\n\"\"\"\nIO.inspect(\"Hello, world!\")\nIO.inspect(\"Goodbye, world!\")\n\"\"\"\n```","ref":"Igniter.Code.Common.html#add_code/3-example"},{"type":"function","title":"Igniter.Code.Common.current_env/1","doc":"Expands the environment at the current zipper position and returns the\nexpanded environment. Currently used for properly working with aliases.","ref":"Igniter.Code.Common.html#current_env/1"},{"type":"function","title":"Igniter.Code.Common.expand_alias/1","doc":"","ref":"Igniter.Code.Common.html#expand_alias/1"},{"type":"function","title":"Igniter.Code.Common.expand_aliases/1","doc":"","ref":"Igniter.Code.Common.html#expand_aliases/1"},{"type":"function","title":"Igniter.Code.Common.expand_literal/1","doc":"Expands a literal value using the env at the cursor, if possible","ref":"Igniter.Code.Common.html#expand_literal/1"},{"type":"function","title":"Igniter.Code.Common.extendable_block?/1","doc":"","ref":"Igniter.Code.Common.html#extendable_block?/1"},{"type":"function","title":"Igniter.Code.Common.find_all/2","doc":"Returns a list of `zippers` to each `node` that satisfies the `predicate` function, or\nan empty list if none are found.\n\nThe optional second parameters specifies the `direction`, defaults to\n`:next`.","ref":"Igniter.Code.Common.html#find_all/2"},{"type":"function","title":"Igniter.Code.Common.maybe_move_to_block/1","doc":"Enters a block, and moves to the first child, or returns the zipper unmodified.","ref":"Igniter.Code.Common.html#maybe_move_to_block/1"},{"type":"function","title":"Igniter.Code.Common.maybe_move_to_single_child_block/1","doc":"Enters a block with a single child, and moves to that child,\nor returns the zipper unmodified","ref":"Igniter.Code.Common.html#maybe_move_to_single_child_block/1"},{"type":"function","title":"Igniter.Code.Common.move_left/2","doc":"Moves a zipper to the left.\n\nIf the second argument is a predicate function, it will be called on the zipper and then\nmove leftwards until the predicate returns `true`. This function will automatically enter\nand exit blocks.\n\nIf the second argument is a non-negative integer, it will move left that many times if\npossible, returning `:error` otherwise.","ref":"Igniter.Code.Common.html#move_left/2"},{"type":"function","title":"Igniter.Code.Common.move_next/2","doc":"Moves nextwards (depth-first), until the provided predicate returns `true`.\n\nReturns `:error` if the end is reached without finding a match.","ref":"Igniter.Code.Common.html#move_next/2"},{"type":"function","title":"Igniter.Code.Common.move_right/2","doc":"Moves a zipper to the right.\n\nIf the second argument is a predicate function, it will be called on the zipper and then\nmove rightwards until the predicate returns `true`. This function will automatically enter\nand exit blocks.\n\nIf the second argument is a non-negative integer, it will move right that many times if\npossible, returning `:error` otherwise.","ref":"Igniter.Code.Common.html#move_right/2"},{"type":"function","title":"Igniter.Code.Common.move_to/2","doc":"Moves to the next node that matches the predicate.","ref":"Igniter.Code.Common.html#move_to/2"},{"type":"function","title":"Igniter.Code.Common.move_to_cursor/2","doc":"Matches and moves to the location of a `__cursor__` in provided source code.\n\nUse `__cursor__()` to match a cursor in the provided source code. Use `__` to skip any code at a point.\n\nFor example:\n\n```elixir\nzipper =\n  \"\"\"\n  if true do\n    10\n  end\n  \"\"\"\n  |> Sourceror.Zipper.zip()\n\npattern =\n  \"\"\"\n  if __ do\n    __cursor__()\n  end\n  \"\"\"\n\nzipper\n|> Igniter.Code.Common.move_to_cursor(pattern)\n|> Zipper.node()\n# => 10\n```","ref":"Igniter.Code.Common.html#move_to_cursor/2"},{"type":"function","title":"Igniter.Code.Common.move_to_cursor_match_in_scope/2","doc":"Moves to the cursor that matches the provided pattern or one of the provided patterns, in the current scope.\n\nSee `move_to_cursor/2` for an example of a pattern","ref":"Igniter.Code.Common.html#move_to_cursor_match_in_scope/2"},{"type":"function","title":"Igniter.Code.Common.move_to_do_block/1","doc":"Moves to a do block for the current call.\n\nFor example, at a node like:\n\n```elixir\nfoo do\n  10\nend\n```\n\nYou would get a zipper back at `10`.","ref":"Igniter.Code.Common.html#move_to_do_block/1"},{"type":"macro","title":"Igniter.Code.Common.move_to_pattern/2","doc":"Moves to the next node that matches the given pattern.","ref":"Igniter.Code.Common.html#move_to_pattern/2"},{"type":"function","title":"Igniter.Code.Common.move_to_zipper/2","doc":"Moves to the next zipper that matches the predicate.","ref":"Igniter.Code.Common.html#move_to_zipper/2"},{"type":"function","title":"Igniter.Code.Common.move_upwards/2","doc":"Moves a zipper upwards.\n\nIf the second argument is a predicate function, it will be called on the zipper and then\nmove upwards until the predicate returns `true`.\n\nIf the second argument is a non-negative integer, it will move upwards that many times if\npossible, returning `:error` otherwise.","ref":"Igniter.Code.Common.html#move_upwards/2"},{"type":"function","title":"Igniter.Code.Common.move_upwards_until/2","doc":"Moves to the last node before the node that matches the predicate, going upwards.","ref":"Igniter.Code.Common.html#move_upwards_until/2"},{"type":"macro","title":"Igniter.Code.Common.node_matches_pattern?/2","doc":"Returns `true` if the current node matches the given pattern.","ref":"Igniter.Code.Common.html#node_matches_pattern?/2"},{"type":"macro","title":"Examples: - Igniter.Code.Common.node_matches_pattern?/2","doc":"```elixir\nlist_zipper =\n  \"[1, 2, 3]\"\n  |> Sourceror.parse_string!()\n  |> Sourceror.Zipper.zip()\n\nCommon.node_matches_pattern?(list_zipper, value when is_list(value)) # true\n```","ref":"Igniter.Code.Common.html#node_matches_pattern?/2-examples"},{"type":"function","title":"Igniter.Code.Common.nodes_equal?/2","doc":"","ref":"Igniter.Code.Common.html#nodes_equal?/2"},{"type":"function","title":"Igniter.Code.Common.nth_right/2","doc":"","ref":"Igniter.Code.Common.html#nth_right/2"},{"type":"function","title":"Igniter.Code.Common.remove/2","doc":"Removes any nodes matching the provided pattern, until there are no matches left.","ref":"Igniter.Code.Common.html#remove/2"},{"type":"function","title":"Igniter.Code.Common.remove_all_matches/2","doc":"Removes all nodes matching the given predicate with the given function.\n\nRecurses until the predicate no longer returns false","ref":"Igniter.Code.Common.html#remove_all_matches/2"},{"type":"function","title":"Igniter.Code.Common.replace_code/2","doc":"Replaces code with new code.","ref":"Igniter.Code.Common.html#replace_code/2"},{"type":"function","title":"Igniter.Code.Common.rightmost/1","doc":"Moves the zipper all the way to the right, potentially entering a single value block.","ref":"Igniter.Code.Common.html#rightmost/1"},{"type":"function","title":"Igniter.Code.Common.single_child_block?/1","doc":"","ref":"Igniter.Code.Common.html#single_child_block?/1"},{"type":"function","title":"Igniter.Code.Common.update_all_matches/3","doc":"Updates all nodes matching the given predicate with the given function.\n\nRecurses until the predicate no longer returns false","ref":"Igniter.Code.Common.html#update_all_matches/3"},{"type":"function","title":"Igniter.Code.Common.use_aliases/2","doc":"Replaces full module names in `new_code` with any aliases for that\nmodule found in the `current_code` environment.","ref":"Igniter.Code.Common.html#use_aliases/2"},{"type":"function","title":"Igniter.Code.Common.within/2","doc":"Runs the function `fun` on the subtree of the currently focused `node` and\nreturns the updated `zipper`.\n\n`fun` must return {:ok, zipper} or `:error`, which may be positioned at the top of the subtree.","ref":"Igniter.Code.Common.html#within/2"},{"type":"module","title":"Igniter.Code.Function","doc":"Utilities for working with functions.","ref":"Igniter.Code.Function.html"},{"type":"function","title":"Igniter.Code.Function.append_argument/2","doc":"Appends an argument to a function call, leaving the zipper at the function call's node.","ref":"Igniter.Code.Function.html#append_argument/2"},{"type":"function","title":"Igniter.Code.Function.argument_equals?/3","doc":"Checks if the provided function call (in a Zipper) has an argument that equals\n`term` at `index`.","ref":"Igniter.Code.Function.html#argument_equals?/3"},{"type":"macro","title":"Igniter.Code.Function.argument_matches_pattern?/3","doc":"Returns `true` if the argument at the provided index exists and matches the provided pattern\n\nNote: to check for argument equality, use `argument_equals?/3` instead.","ref":"Igniter.Code.Function.html#argument_matches_pattern?/3"},{"type":"function","title":"Igniter.Code.Function.argument_matches_predicate?/3","doc":"Returns true if the argument at the given index matches the provided predicate","ref":"Igniter.Code.Function.html#argument_matches_predicate?/3"},{"type":"function","title":"Igniter.Code.Function.function/3","doc":"","ref":"Igniter.Code.Function.html#function/3"},{"type":"function","title":"Igniter.Code.Function.function?/3","doc":"Returns true if the value is a function literal.\n\nExamples:\n  - `fn x -> x end`\n  - `&(&1 + &2)`\n  - `&SomeMod.fun/2`\n\nTo refine the check, you can use `name` and `arity`.","ref":"Igniter.Code.Function.html#function?/3"},{"type":"function","title":"Names - Igniter.Code.Function.function?/3","doc":"- `:any` - matches any function literal, named or not\n- `:any_named` - matches any named function literal\n- `:anonymous` - matches any anonymous function literal\n- `{module, name}` - matches a function literal with the given module and name","ref":"Igniter.Code.Function.html#function?/3-names"},{"type":"function","title":"Igniter.Code.Function.function_call?/1","doc":"Returns `true` if the node is a function call","ref":"Igniter.Code.Function.html#function_call?/1"},{"type":"function","title":"Igniter.Code.Function.function_call?/3","doc":"Returns `true` if the node is a function call of the given name\n\nIf an `atom` is provided, it only matches functions in the form of `function(name)`.\n\nIf an `{module, atom}` is provided, it matches functions called on the given module,\ntaking into account any imports or aliases.","ref":"Igniter.Code.Function.html#function_call?/3"},{"type":"function","title":"Igniter.Code.Function.get_local_function_call/1","doc":"Gets the name and arity of a local function call.\n\nReturns `:error` if the node is not a function call or cannot be determined.","ref":"Igniter.Code.Function.html#get_local_function_call/1"},{"type":"function","title":"Igniter.Code.Function.get_local_function_call_name/1","doc":"Gets the name of a local function call.\n\nReturns `:error` if the node is not a function call or cannot be determined.","ref":"Igniter.Code.Function.html#get_local_function_call_name/1"},{"type":"function","title":"Igniter.Code.Function.move_to_def/1","doc":"","ref":"Igniter.Code.Function.html#move_to_def/1"},{"type":"function","title":"Igniter.Code.Function.move_to_def/3","doc":"","ref":"Igniter.Code.Function.html#move_to_def/3"},{"type":"function","title":"Igniter.Code.Function.move_to_defp/3","doc":"","ref":"Igniter.Code.Function.html#move_to_defp/3"},{"type":"function","title":"Igniter.Code.Function.move_to_function_call/4","doc":"Moves to a function call by the given name and arity, matching the given predicate, in the current or lower scope","ref":"Igniter.Code.Function.html#move_to_function_call/4"},{"type":"function","title":"Igniter.Code.Function.move_to_function_call_in_current_scope/4","doc":"Moves to a function call by the given name and arity, matching the given predicate, in the current scope","ref":"Igniter.Code.Function.html#move_to_function_call_in_current_scope/4"},{"type":"function","title":"Igniter.Code.Function.move_to_nth_argument/2","doc":"Moves to the `nth` argument of a function call.","ref":"Igniter.Code.Function.html#move_to_nth_argument/2"},{"type":"function","title":"Igniter.Code.Function.update_nth_argument/3","doc":"Updates the `nth` argument of a function call, leaving the zipper at the function call's node.","ref":"Igniter.Code.Function.html#update_nth_argument/3"},{"type":"module","title":"Igniter.Code.Keyword","doc":"Utilities for working with keyword.","ref":"Igniter.Code.Keyword.html"},{"type":"function","title":"Igniter.Code.Keyword.get_key/2","doc":"Moves the zipper to the value of `key` in a keyword list.","ref":"Igniter.Code.Keyword.html#get_key/2"},{"type":"function","title":"Igniter.Code.Keyword.keyword_has_path?/2","doc":"Returns true if the node is a nested keyword list containing a value at the given path.","ref":"Igniter.Code.Keyword.html#keyword_has_path?/2"},{"type":"function","title":"Igniter.Code.Keyword.keywordify/2","doc":"Puts into nested keyword lists represented by `path`","ref":"Igniter.Code.Keyword.html#keywordify/2"},{"type":"function","title":"Igniter.Code.Keyword.put_in_keyword/4","doc":"Puts a value at a path into a keyword, calling `updater` on the zipper at the value if the key is already present","ref":"Igniter.Code.Keyword.html#put_in_keyword/4"},{"type":"function","title":"Igniter.Code.Keyword.remove_keyword_key/2","doc":"Removes a key from a keyword list if present. Returns `:error` only if the node is not a list","ref":"Igniter.Code.Keyword.html#remove_keyword_key/2"},{"type":"function","title":"Igniter.Code.Keyword.set_keyword_key/4","doc":"","ref":"Igniter.Code.Keyword.html#set_keyword_key/4"},{"type":"module","title":"Igniter.Code.List","doc":"Utilities for working with lists.","ref":"Igniter.Code.List.html"},{"type":"function","title":"Igniter.Code.List.append_new_to_list/3","doc":"Appends `quoted` to the list unless it is already present, determined by `equality_pred`.","ref":"Igniter.Code.List.html#append_new_to_list/3"},{"type":"function","title":"Igniter.Code.List.append_to_list/2","doc":"Appends `quoted` to the list","ref":"Igniter.Code.List.html#append_to_list/2"},{"type":"function","title":"Igniter.Code.List.do_move_to_list_item/2","doc":"Moves to the list item matching the given predicate, assuming you are currently inside the list","ref":"Igniter.Code.List.html#do_move_to_list_item/2"},{"type":"type","title":"Igniter.Code.List.equality_pred/0","doc":"","ref":"Igniter.Code.List.html#t:equality_pred/0"},{"type":"function","title":"Igniter.Code.List.find_list_item_index/2","doc":"Finds the index of the first list item that satisfies `pred`","ref":"Igniter.Code.List.html#find_list_item_index/2"},{"type":"function","title":"Igniter.Code.List.list?/1","doc":"Returns true if the `zipper` is at a list literal","ref":"Igniter.Code.List.html#list?/1"},{"type":"function","title":"Igniter.Code.List.map/2","doc":"Moves to the list item matching the given predicate","ref":"Igniter.Code.List.html#map/2"},{"type":"function","title":"Igniter.Code.List.move_to_list_item/2","doc":"Moves to the list item matching the given predicate","ref":"Igniter.Code.List.html#move_to_list_item/2"},{"type":"function","title":"Igniter.Code.List.prepend_new_to_list/3","doc":"Prepends `quoted` to the list unless it is already present, determined by `equality_pred`.","ref":"Igniter.Code.List.html#prepend_new_to_list/3"},{"type":"function","title":"Igniter.Code.List.prepend_to_list/2","doc":"Prepends `quoted` to the list","ref":"Igniter.Code.List.html#prepend_to_list/2"},{"type":"function","title":"Igniter.Code.List.remove_from_list/2","doc":"","ref":"Igniter.Code.List.html#remove_from_list/2"},{"type":"function","title":"Igniter.Code.List.remove_index/2","doc":"Removes the item at the given index, returning `:error` if nothing is at that index","ref":"Igniter.Code.List.html#remove_index/2"},{"type":"function","title":"Igniter.Code.List.replace_in_list/3","doc":"","ref":"Igniter.Code.List.html#replace_in_list/3"},{"type":"module","title":"Igniter.Code.Map","doc":"Utilities for working with maps.","ref":"Igniter.Code.Map.html"},{"type":"function","title":"Igniter.Code.Map.mappify/2","doc":"Puts a value into nested maps at the given path","ref":"Igniter.Code.Map.html#mappify/2"},{"type":"function","title":"Igniter.Code.Map.put_in_map/4","doc":"Puts a value at a path into a map, calling `updater` on the zipper at the value if the key is already present","ref":"Igniter.Code.Map.html#put_in_map/4"},{"type":"function","title":"Igniter.Code.Map.set_map_key/4","doc":"Puts a key into a map, calling `updater` on the zipper at the value if the key is already present","ref":"Igniter.Code.Map.html#set_map_key/4"},{"type":"module","title":"Igniter.Code.Module","doc":"Utilities for working with Elixir modules","ref":"Igniter.Code.Module.html"},{"type":"function","title":"Igniter.Code.Module.create_module/4","doc":"Creates a new file & module in its appropriate location.","ref":"Igniter.Code.Module.html#create_module/4"},{"type":"function","title":"Igniter.Code.Module.find_all_matching_modules/2","doc":"","ref":"Igniter.Code.Module.html#find_all_matching_modules/2"},{"type":"function","title":"Igniter.Code.Module.find_and_update_module/3","doc":"Finds a module and updates its contents. Returns `{:error, igniter}` if the module could not be found. Do not discard this igniter.","ref":"Igniter.Code.Module.html#find_and_update_module/3"},{"type":"function","title":"Igniter.Code.Module.find_and_update_module!/3","doc":"","ref":"Igniter.Code.Module.html#find_and_update_module!/3"},{"type":"function","title":"Igniter.Code.Module.find_and_update_or_create_module/5","doc":"Finds a module and updates its contents wherever it is.\n\nIf the module does not yet exist, it is created with the provided contents. In that case,\nthe path is determined with `Igniter.Code.Module.proper_location/2`, but may optionally be overwritten with options below.\n\n# Options\n\n- `:path` - Path where to create the module, relative to the project root. Default: `nil` (uses `:kind` to determine the path).","ref":"Igniter.Code.Module.html#find_and_update_or_create_module/5"},{"type":"function","title":"Igniter.Code.Module.find_module/2","doc":"Finds a module, returning a new igniter, and the source and zipper location. This new igniter should not be discarded.\n\nIn general, you should not use the returned source and zipper to update the module, instead, use this to interrogate\nthe contents or source in some way, and then call `find_and_update_module/3` with a function to perform an update.","ref":"Igniter.Code.Module.html#find_module/2"},{"type":"function","title":"Igniter.Code.Module.find_module!/2","doc":"Finds a module, raising an error if its not found.\n\nSee `find_module/2` for more information.","ref":"Igniter.Code.Module.html#find_module!/2"},{"type":"function","title":"Igniter.Code.Module.module?/1","doc":"","ref":"Igniter.Code.Module.html#module?/1"},{"type":"function","title":"Igniter.Code.Module.module_exists?/2","doc":"Checks if a module is defined somewhere in the project. The returned igniter should not be discarded.","ref":"Igniter.Code.Module.html#module_exists?/2"},{"type":"function","title":"Igniter.Code.Module.module_matching?/2","doc":"Checks if the value is a module that matches a given predicate","ref":"Igniter.Code.Module.html#module_matching?/2"},{"type":"function","title":"Igniter.Code.Module.module_name/1","doc":"Given a suffix, returns a module name with the prefix of the current project.","ref":"Igniter.Code.Module.html#module_name/1"},{"type":"function","title":"Igniter.Code.Module.module_name/2","doc":"Given a suffix, returns a module name with the prefix of the current project.","ref":"Igniter.Code.Module.html#module_name/2"},{"type":"function","title":"Igniter.Code.Module.module_name_prefix/0","doc":"The module name prefix based on the mix project's module name","ref":"Igniter.Code.Module.html#module_name_prefix/0"},{"type":"function","title":"Igniter.Code.Module.module_name_prefix/1","doc":"The module name prefix based on the mix project's module name","ref":"Igniter.Code.Module.html#module_name_prefix/1"},{"type":"function","title":"Igniter.Code.Module.move_to_def/3","doc":"","ref":"Igniter.Code.Module.html#move_to_def/3"},{"type":"function","title":"Igniter.Code.Module.move_to_defmodule/1","doc":"Moves the zipper to a defmodule call","ref":"Igniter.Code.Module.html#move_to_defmodule/1"},{"type":"function","title":"Igniter.Code.Module.move_to_defmodule/2","doc":"Moves the zipper to a specific defmodule call","ref":"Igniter.Code.Module.html#move_to_defmodule/2"},{"type":"function","title":"Igniter.Code.Module.move_to_defp/3","doc":"","ref":"Igniter.Code.Module.html#move_to_defp/3"},{"type":"function","title":"Igniter.Code.Module.move_to_module_using/2","doc":"Moves the zipper to the body of a module that `use`s the provided module (or one of the provided modules).","ref":"Igniter.Code.Module.html#move_to_module_using/2"},{"type":"function","title":"Igniter.Code.Module.move_to_use/2","doc":"Moves the zipper to the `use` statement for a provided module.","ref":"Igniter.Code.Module.html#move_to_use/2"},{"type":"function","title":"Igniter.Code.Module.move_to_using/2","doc":"","ref":"Igniter.Code.Module.html#move_to_using/2"},{"type":"function","title":"Igniter.Code.Module.parse/1","doc":"Parses a string into a module name","ref":"Igniter.Code.Module.html#parse/1"},{"type":"function","title":"Igniter.Code.Module.proper_location/2","doc":"Returns the idiomatic file location for a given module, starting with \"lib/\".","ref":"Igniter.Code.Module.html#proper_location/2"},{"type":"function","title":"Igniter.Code.Module.proper_test_location/1","doc":"Returns the test file location for a given module, according to\n`mix test` expectations, starting with \"test/\" and ending with \"_test.exs\".","ref":"Igniter.Code.Module.html#proper_test_location/1"},{"type":"function","title":"Igniter.Code.Module.proper_test_support_location/1","doc":"Returns the test support location for a given module, starting with\n\"test/support/\" and dropping the module name prefix in the path.","ref":"Igniter.Code.Module.html#proper_test_support_location/1"},{"type":"module","title":"Igniter.Code.String","doc":"Utilities for working with strings.","ref":"Igniter.Code.String.html"},{"type":"function","title":"Igniter.Code.String.string?/1","doc":"Returns true if the node represents a literal string, false otherwise.","ref":"Igniter.Code.String.html#string?/1"},{"type":"function","title":"Igniter.Code.String.update_string/2","doc":"Updates a node representing a string with the result of the given function","ref":"Igniter.Code.String.html#update_string/2"},{"type":"module","title":"Igniter.Code.Tuple","doc":"Utilities for working with tuples.","ref":"Igniter.Code.Tuple.html"},{"type":"function","title":"Igniter.Code.Tuple.append_elem/2","doc":"Appends `quoted` to the elem","ref":"Igniter.Code.Tuple.html#append_elem/2"},{"type":"function","title":"Igniter.Code.Tuple.elem_equals?/3","doc":"","ref":"Igniter.Code.Tuple.html#elem_equals?/3"},{"type":"function","title":"Igniter.Code.Tuple.tuple?/1","doc":"Returns `true` if the zipper is at a literal tuple, `false` if not.","ref":"Igniter.Code.Tuple.html#tuple?/1"},{"type":"function","title":"Igniter.Code.Tuple.tuple_elem/2","doc":"Returns a zipper at the tuple element at the given index, or `:error` if the index is out of bounds.","ref":"Igniter.Code.Tuple.html#tuple_elem/2"},{"type":"behaviour","title":"Igniter.Extension","doc":"Alter igniter's behavior by adding new functionality.\n\nThis is used to allow frameworks to modify things like\nthe conventional location of files.","ref":"Igniter.Extension.html"},{"type":"callback","title":"Igniter.Extension.proper_location/3","doc":"Choose a proper location for any given module.\n\nPossible return values:\n\n- `{:ok, path}`: The path where the module should be located.\n- `:error`: It should go in the default place, or according to other extensions.\n- `:keep`: Keep the module in the same location, unless another extension has a place for it, or its just been created.","ref":"Igniter.Extension.html#c:proper_location/3"},{"type":"module","title":"Igniter.Extensions.Phoenix","doc":"A phoenix extension for Igniter.\n\nInstall with `mix igniter.add_extension phoenix`","ref":"Igniter.Extensions.Phoenix.html"},{"type":"function","title":"Igniter.Extensions.Phoenix.proper_location/3","doc":"","ref":"Igniter.Extensions.Phoenix.html#proper_location/3"},{"type":"module","title":"Igniter.Libs.Ecto","doc":"Codemods & utilities for working with Ecto","ref":"Igniter.Libs.Ecto.html"},{"type":"function","title":"Igniter.Libs.Ecto.gen_migration/4","doc":"Generates a new migration file for the given repo.","ref":"Igniter.Libs.Ecto.html#gen_migration/4"},{"type":"function","title":"Options - Igniter.Libs.Ecto.gen_migration/4","doc":"- `:body` - the body of the migration\n- `:timestamp` - the timestamp to use for the migration.\n   Primarily useful for testing so you know what the filename will be.\n- `:on_exists` - what to do if the migration *module* already exists. Options are:\n  - `:increment` - Calls this function again, but with an increasing number at the end, until it finds a free name. (default)\n  - `:skip` - do nothing\n  - `:overwrite` - overwrites the file\n  - `{:error, error}` - adds an issue to the igniter that prevents writing and displays to the user\n  - `{:warning, warning}` - adds a warning to the igniter that allows writing but displays to the user","ref":"Igniter.Libs.Ecto.html#gen_migration/4-options"},{"type":"function","title":"Igniter.Libs.Ecto.list_repos/1","doc":"Lists all the ecto repos in the project","ref":"Igniter.Libs.Ecto.html#list_repos/1"},{"type":"function","title":"Igniter.Libs.Ecto.select_repo/2","doc":"Selects a repo module from the list of available repos.","ref":"Igniter.Libs.Ecto.html#select_repo/2"},{"type":"function","title":"Options - Igniter.Libs.Ecto.select_repo/2","doc":"* `:label` - The label to display to the user when selecting the repo","ref":"Igniter.Libs.Ecto.html#select_repo/2-options"},{"type":"module","title":"Igniter.Libs.Phoenix","doc":"Codemods & utilities for working with Phoenix","ref":"Igniter.Libs.Phoenix.html"},{"type":"function","title":"Igniter.Libs.Phoenix.add_pipeline/4","doc":"Adds a pipeline to a Phoenix router.","ref":"Igniter.Libs.Phoenix.html#add_pipeline/4"},{"type":"function","title":"Options - Igniter.Libs.Phoenix.add_pipeline/4","doc":"* `:router` - The router module to append to. Will be looked up if not provided.\n* `:arg2` - The second argument to the scope macro. Must be a value (typically a module).","ref":"Igniter.Libs.Phoenix.html#add_pipeline/4-options"},{"type":"function","title":"Igniter.Libs.Phoenix.add_scope/4","doc":"Adds a scope to a Phoenix router.","ref":"Igniter.Libs.Phoenix.html#add_scope/4"},{"type":"function","title":"Options - Igniter.Libs.Phoenix.add_scope/4","doc":"* `:router` - The router module to append to. Will be looked up if not provided.\n* `:arg2` - The second argument to the scope macro. Must be a value (typically a module).","ref":"Igniter.Libs.Phoenix.html#add_scope/4-options"},{"type":"function","title":"Igniter.Libs.Phoenix.append_to_pipeline/4","doc":"Appends code to a Phoenix router pipeline.","ref":"Igniter.Libs.Phoenix.html#append_to_pipeline/4"},{"type":"function","title":"Options - Igniter.Libs.Phoenix.append_to_pipeline/4","doc":"* `:router` - The router module to append to. Will be looked up if not provided.","ref":"Igniter.Libs.Phoenix.html#append_to_pipeline/4-options"},{"type":"function","title":"Igniter.Libs.Phoenix.append_to_scope/4","doc":"Appends to a phoenix router scope.\n\nRelatively limited currently only exact matches of a top level route, second argument, and pipelines.","ref":"Igniter.Libs.Phoenix.html#append_to_scope/4"},{"type":"function","title":"Options - Igniter.Libs.Phoenix.append_to_scope/4","doc":"* `:router` - The router module to append to. Will be looked up if not provided.\n* `:arg2` - The second argument to the scope macro. Must be a value (typically a module).\n* `:with_pipelines` - A list of pipelines that the pipeline must be using to be considered a match.","ref":"Igniter.Libs.Phoenix.html#append_to_scope/4-options"},{"type":"function","title":"Igniter.Libs.Phoenix.controller?/2","doc":"Returns `true` if the module is a Phoenix controller","ref":"Igniter.Libs.Phoenix.html#controller?/2"},{"type":"function","title":"Igniter.Libs.Phoenix.endpoints_for_router/2","doc":"Gets the list of endpoints that use a given router","ref":"Igniter.Libs.Phoenix.html#endpoints_for_router/2"},{"type":"function","title":"Igniter.Libs.Phoenix.has_pipeline/3","doc":"Returns `{igniter, true}` if a pipeline exists in a Phoenix router, and `{igniter, false}` otherwise.","ref":"Igniter.Libs.Phoenix.html#has_pipeline/3"},{"type":"function","title":"Options - Igniter.Libs.Phoenix.has_pipeline/3","doc":"* `:router` - The router module to append to. Will be looked up if not provided.\n* `:arg2` - The second argument to the scope macro. Must be a value (typically a module).","ref":"Igniter.Libs.Phoenix.html#has_pipeline/3-options"},{"type":"function","title":"Igniter.Libs.Phoenix.html?/2","doc":"Returns `true` if the module is a Phoenix HTML module","ref":"Igniter.Libs.Phoenix.html#html?/2"},{"type":"function","title":"Igniter.Libs.Phoenix.list_routers/1","doc":"Lists all routers found in the project.","ref":"Igniter.Libs.Phoenix.html#list_routers/1"},{"type":"function","title":"Igniter.Libs.Phoenix.move_to_router_use/2","doc":"Moves to the use statement in a module that matches `use TheirWebModule, :router`","ref":"Igniter.Libs.Phoenix.html#move_to_router_use/2"},{"type":"function","title":"Igniter.Libs.Phoenix.prepend_to_pipeline/4","doc":"Prepends code to a Phoenix router pipeline.","ref":"Igniter.Libs.Phoenix.html#prepend_to_pipeline/4"},{"type":"function","title":"Options - Igniter.Libs.Phoenix.prepend_to_pipeline/4","doc":"* `:router` - The router module to append to. Will be looked up if not provided.","ref":"Igniter.Libs.Phoenix.html#prepend_to_pipeline/4-options"},{"type":"function","title":"Igniter.Libs.Phoenix.select_endpoint/3","doc":"Selects an endpoint to be used in a later step. If only one endpoint is found, it will be selected automatically.\n\nIf no endpoints exist, `{igniter, nil}` is returned.\n\nIf multiple endpoints are found, the user is prompted to select one of them.","ref":"Igniter.Libs.Phoenix.html#select_endpoint/3"},{"type":"function","title":"Igniter.Libs.Phoenix.select_router/2","doc":"Selects a router to be used in a later step. If only one router is found, it will be selected automatically.\n\nIf no routers exist, `{igniter, nil}` is returned.\n\nIf multiple routes are found, the user is prompted to select one of them.","ref":"Igniter.Libs.Phoenix.html#select_router/2"},{"type":"function","title":"Igniter.Libs.Phoenix.web_module/1","doc":"Returns the web module name for the current app","ref":"Igniter.Libs.Phoenix.html#web_module/1"},{"type":"function","title":"Igniter.Libs.Phoenix.web_module_name/0","doc":"Returns the web module name for the current app","ref":"Igniter.Libs.Phoenix.html#web_module_name/0"},{"type":"function","title":"Igniter.Libs.Phoenix.web_module_name/1","doc":"Generates a module name that lives in the Web directory of the current app.","ref":"Igniter.Libs.Phoenix.html#web_module_name/1"},{"type":"function","title":"Igniter.Libs.Phoenix.web_module_name/2","doc":"Generates a module name that lives in the Web directory of the current app.","ref":"Igniter.Libs.Phoenix.html#web_module_name/2"},{"type":"module","title":"Igniter.Libs.Swoosh","doc":"Codemods & utilities for working with Swoosh","ref":"Igniter.Libs.Swoosh.html"},{"type":"function","title":"Igniter.Libs.Swoosh.list_mailers/1","doc":"Lists all project modules that call `use Swoosh.Mailer`.","ref":"Igniter.Libs.Swoosh.html#list_mailers/1"},{"type":"function","title":"Igniter.Libs.Swoosh.move_to_mailer_use/1","doc":"Moves to the use statement in a module that matches `use Swoosh.Mailer`","ref":"Igniter.Libs.Swoosh.html#move_to_mailer_use/1"},{"type":"module","title":"Igniter.Util.Debug","doc":"Tools for debugging zippers.","ref":"Igniter.Util.Debug.html"},{"type":"function","title":"Igniter.Util.Debug.code_at_node/1","doc":"Returns the formatted code at the node of the zipper to the console","ref":"Igniter.Util.Debug.html#code_at_node/1"},{"type":"function","title":"Igniter.Util.Debug.puts_ast_at_node/1","doc":"Puts the ast at the node of the zipper to the console","ref":"Igniter.Util.Debug.html#puts_ast_at_node/1"},{"type":"function","title":"Igniter.Util.Debug.puts_code_at_node/1","doc":"Puts the formatted code at the node of the zipper to the console","ref":"Igniter.Util.Debug.html#puts_code_at_node/1"},{"type":"module","title":"Igniter.Util.IO","doc":"Helpers for working with input/output","ref":"Igniter.Util.IO.html"},{"type":"function","title":"Igniter.Util.IO.select/3","doc":"Prompts the user to select from a list, repeating until an item is selected","ref":"Igniter.Util.IO.html#select/3"},{"type":"function","title":"Options - Igniter.Util.IO.select/3","doc":"- `display`: A function that takes an item and returns a string to display","ref":"Igniter.Util.IO.html#select/3-options"},{"type":"function","title":"Igniter.Util.IO.yes?/1","doc":"Prompts the user for yes or no, repeating the prompt until a satisfactory answer is given","ref":"Igniter.Util.IO.html#yes?/1"},{"type":"module","title":"Igniter.Util.Install","doc":"Tools for installing packages and running their associated\ninstallers, if present.\n\n[!NOTE]\nThe functions in this module are not composable, and are primarily meant to\nbe used internally and to support building custom tooling on top of Igniter,\nsuch as [Fireside](https://github.com/ibarakaiev/fireside).","ref":"Igniter.Util.Install.html"},{"type":"function","title":"Igniter.Util.Install.get_deps!/2","doc":"","ref":"Igniter.Util.Install.html#get_deps!/2"},{"type":"function","title":"Igniter.Util.Install.install/4","doc":"Installs the provided list of dependencies. `deps` can be either:\n- a string like `\"ash,ash_postgres\"`\n- a list of strings like `[\"ash\", \"ash_postgres\", ...]`\n- a list of tuples like `[{:ash, \"~> 3.0\"}, {:ash_postgres, \"~> 2.0\"}]`","ref":"Igniter.Util.Install.html#install/4"},{"type":"module","title":"Igniter.Util.Loading","doc":"Utilities for doing operations with loading spinners.","ref":"Igniter.Util.Loading.html"},{"type":"function","title":"Igniter.Util.Loading.spawn_loader/1","doc":"","ref":"Igniter.Util.Loading.html#spawn_loader/1"},{"type":"function","title":"Igniter.Util.Loading.with_log/2","doc":"","ref":"Igniter.Util.Loading.html#with_log/2"},{"type":"function","title":"Igniter.Util.Loading.with_spinner/3","doc":"Runs the function with a loading spinner, suppressing all output.","ref":"Igniter.Util.Loading.html#with_spinner/3"},{"type":"module","title":"Igniter.Util.Version","doc":"Utilities for working versions and version requirements","ref":"Igniter.Util.Version.html"},{"type":"function","title":"Igniter.Util.Version.version_string_to_general_requirement/1","doc":"","ref":"Igniter.Util.Version.html#version_string_to_general_requirement/1"},{"type":"function","title":"Igniter.Util.Version.version_string_to_general_requirement!/1","doc":"Provides a general requirement for a given version string.\n\nFor example\n\n`3.1.2` would be `~> 3.0`\nand\n`0.2.4` would be `~> 0.2`","ref":"Igniter.Util.Version.html#version_string_to_general_requirement!/1"},{"type":"module","title":"Igniter.Util.Warning","doc":"Utilities for emitting well formatted warnings","ref":"Igniter.Util.Warning.html"},{"type":"function","title":"Igniter.Util.Warning.formatted_warning/2","doc":"","ref":"Igniter.Util.Warning.html#formatted_warning/2"},{"type":"function","title":"Igniter.Util.Warning.warn_with_code_sample/3","doc":"","ref":"Igniter.Util.Warning.html#warn_with_code_sample/3"},{"type":"extras","title":"Home","doc":"[![CI](https://github.com/ash-project/igniter/actions/workflows/elixir.yml/badge.svg)](https://github.com/ash-project/igniter/actions/workflows/elixir.yml)\n[![Hex version badge](https://img.shields.io/hexpm/v/igniter.svg)](https://hex.pm/packages/igniter)\n[![Hexdocs badge](https://img.shields.io/badge/docs-hexdocs-purple)](https://hexdocs.pm/igniter)\n\n# Igniter\n\nIgniter is a code generation and project patching framework.","ref":"readme.html"},{"type":"extras","title":"For library authors and platform teams - Home","doc":"This is a tool kit for writing smarter generators that can semantically create and modify existing files.","ref":"readme.html#for-library-authors-and-platform-teams"},{"type":"extras","title":"For end-users - Home","doc":"","ref":"readme.html#for-end-users"},{"type":"extras","title":"Installers - Home","doc":"You can install new dependencies `mix igniter.install`, which will _add it to your mix.exs automatically_ and then run\nthat library's installer if it has one. Even when libraries don't have an installer, or use igniter, this behavior\nmakes it useful to keep around.","ref":"readme.html#installers"},{"type":"extras","title":"Upgraders - Home","doc":"You can upgrade dependencies with `mix igniter.upgrade`, as a drop on replacement for `mix deps.update`. This\nwill update your dependencies and run any upgrade patchers defined in the target package (if there are any).\n\nSee [upgrades guide](/documentation/upgrades.md) guide for more.","ref":"readme.html#upgraders"},{"type":"extras","title":"Refactors - Home","doc":"In addition to providing tools for library authors to patch your code, common operations are available to use as needed.\n\n- `mix igniter.refactor.rename_function` - Use this to rename a function in your application, along with all references to it.","ref":"readme.html#refactors"},{"type":"extras","title":"Others - Home","doc":"- `mix igniter.update_gettext` - Use this to update gettext if your version is lower than 0.26.1 and you are seeing a compile warning\n  about gettext backends.","ref":"readme.html#others"},{"type":"extras","title":"Installation - Home","doc":"","ref":"readme.html#installation"},{"type":"extras","title":"Standard Installation - Home","doc":"Igniter can be added to an existing elixir project by adding it to your dependencies:\n\n```elixir\n{:igniter, \"~> 0.5\", only: [:dev, :test]}\n```\n\nYou can also generate new projects with igniter preinstalled, and run installers in the same command.\n\nFirst, install the archive:\n\n```elixir\nmix archive.install hex igniter_new\n```\n\nThen you can run `mix igniter.new`\n\n```\nmix igniter.new app_name --install ash\n```\n\nOr if you want to use a different project creator, specify the mix task name with the `--with` flag. Any arguments will be passed through to that task, with the exception of `--install` and `--example`.\n\n```\nmix igniter.new app_name --install ash --with phx.new --with-args=\"--no-ecto\"\n```","ref":"readme.html#standard-installation"},{"type":"extras","title":"Library Authors - Home","doc":"For library authors, add igniter like so:\n\n```elixir\n{:igniter, \"~> 0.5\", optional: true}\n```\n\nThis ensures that end users can install as outlined above, and `:igniter` will not be compiled into their production application.","ref":"readme.html#library-authors"},{"type":"extras","title":"Patterns - Home","doc":"Mix tasks built with igniter are both individually callable, _and_ composable. This means that tasks can call each other, and also end users can create and customize their own generators composing existing tasks.","ref":"readme.html#patterns"},{"type":"extras","title":"Installers - Home","doc":"Igniter will look for a task called ` .install` when the user runs `mix igniter.install  `, and will run it after installing and fetching dependencies.\n\nTo create your installer, use `mix igniter.gen.task  .install`","ref":"readme.html#installers"},{"type":"extras","title":"Generators/Patchers - Home","doc":"These can be run like any other mix task, or composed together. For example, lets say that you wanted to have your own `Ash.Resource` generator, that starts with the default `mix ash.gen.resource` task, but then adds or modifies files:\n\nTo create your generator, use `mix igniter.gen.task  .task.name`\n\n```elixir\n# in lib/mix/tasks/my_app.gen.resource.ex\ndefmodule Mix.Tasks.MyApp.Gen.Resource do\n  use Igniter.Mix.Task\n\n  @impl Igniter.Mix.Task\n  def igniter(igniter) do\n    [resource | _] = igniter.args.argv\n\n    resource = Igniter.Code.Module.parse(resource)\n    my_special_thing = Module.concat([resource, SpecialThing])\n    location = Igniter.Code.Module.proper_location(my_special_thing)\n\n    igniter\n    |> Igniter.compose_task(\"ash.gen.resource\", igniter.args.argv)\n    |> Igniter.Project.Module.create_module(my_special_thing, \"\"\"\n      # this is the special thing for #{inspect()}\n    \"\"\")\n  end\nend\n```","ref":"readme.html#generators-patchers"},{"type":"extras","title":"Upgrading to 0.4.x - Home","doc":"You may notice an issue running `mix igniter.upgrade` if you are using `0.3.x` versions.\nyou must manually upgrade igniter (by editing your `mix.exs` file or running `mix deps.update`)\nto a version greater than or equal to `0.3.78` before running `mix igniter.upgrade`. A problem\nwas discovered with the process of igniter upgrading itself or one of its dependencies.\n\nIn any case where igniter must both download and compile a new version of itself, it will exit\nand print instructions with a command you can run to complete the upgrade. For example:\n\n`mix igniter.apply_upgrades igniter:0.4.0:0.5.0 package:0.1.3:0.1.4`","ref":"readme.html#upgrading-to-0-4-x"},{"type":"extras","title":"Writing Generators","doc":"# Writing Generators\n\nIn `Igniter`, generators are done as a wrapper around `Mix.Task`, allowing them to be called individually or composed as part of a task.\n\nSince an example is worth a thousand words, lets take a look at an example that generates a file and ensures a configuration is set in the user's `config.exs`.\n\n>","ref":"writing-generators.html"},{"type":"extras","title":"An igniter for igniters?! {: .info} - Writing Generators","doc":">\n> Run `mix igniter.gen.task your_app.task.name` to generate a new, fully configured igniter task!\n\n```elixir\n# lib/mix/tasks/your_lib.gen.your_thing.ex\ndefmodule Mix.Tasks.YourLib.Gen.YourThing do\n  use Igniter.Mix.Task\n\n  @impl Igniter.Mix.Task\n  def igniter(igniter) do\n    [module_name | _] = igniter.args.argv\n\n    module_name = Igniter.Code.Module.parse(module_name)\n    path = Igniter.Code.Module.proper_location(module_name)\n    app_name = Igniter.Project.Application.app_name(igniter)\n\n    igniter\n    |> Igniter.create_new_elixir_file(path, \"\"\"\n    defmodule #{inspect(module_name)} do\n      use YourLib.Thing\n\n      ...some_code\n    end\n    \"\"\")\n    |> Igniter.Project.Config.configure(\n      \"config.exs\",\n      app_name,\n      [:list_of_things],\n      [module_name],\n      &Igniter.Code.List.prepend_new_to_list(&1, module_name)\n    )\n  end\nend\n```\n\nNow, your users can run\n\n`mix your_lib.gen.your_thing MyApp.MyModuleName`\n\nand it will present them with a diff, creating a new file and updating their `config.exs`.\n\nAdditionally, other generators can \"compose\" this generator using `Igniter.compose_task/3`\n\n```elixir\nigniter\n|> Igniter.compose_task(Mix.Tasks.YourLib.Gen.YourThing, [\"MyApp.MyModuleName\"])\n|> Igniter.compose_task(Mix.Tasks.YourLib.Gen.YourThing, [\"MyApp.SomeOtherName\"])\n```","ref":"writing-generators.html#an-igniter-for-igniters-info"},{"type":"extras","title":"Writing a library installer - Writing Generators","doc":"Igniter will look for a mix task called `your_library.install` when a user runs `mix igniter.install your_library`. As long as it has the correct name, it will be run automatically as part of installation!","ref":"writing-generators.html#writing-a-library-installer"},{"type":"extras","title":"Task Groups - Writing Generators","doc":"Igniter allows for _composing_ tasks, which means that many igniter tasks can be run in tandem. This happens automatically when using `mix igniter.install`, for example:\n`mix igniter.install package1 package2`. You can also do this manually by using `Igniter.compose_task/3`. See the example above.\n\nHowever, composing tasks means that sometimes a flag from one task may conflict with a flag from another task. Igniter will alert users when this happens, and ask them to\nprefix the option with your task name. For example, the user may see an error like this:\n\n```sh\nAmbiguous flag provided `--option`.\n\nThe task or task groups `package1, package2` all define the flag `--option`.\n\nTo disambiguate, provide the arg as `-- .option`,\nwhere ` ` is the task or task group name.\n\nFor example:\n\n`--package1.option`\n```\n\nIt is not possible to prevent this from happening for all combinations of invocations of your task, but you can help by using a `group`.\n\n```elixir\n%Igniter.Mix.Task.Info{\n  group: :your_package,\n  ...\n}\n```\n\nSetting this group performs two functions:\n\n1. any tasks that share a group with each other will be assumed that the same flag has the same meaning. That way,\n   users don't have to disambiguate when calling `mix igniter.install yourthing1 yourthing2 --option`, because it is assumed\n   to have the same meaning.\n2. it can provide a shorter/semantic name to type, i.e instead of `--ash-authentication-phoenix.install.domain` it could be just `--ash.domain`.\n\nBy default the group name is the _full task name_. We suggest setting a group for all of your tasks.\nYou should _not_ use a group name that is used by someone else, just like you should not use a module prefix used by someone else in general.","ref":"writing-generators.html#task-groups"},{"type":"extras","title":"Navigating the Igniter Codebase - Writing Generators","doc":"A large part of writing generators with igniter is leveraging our built-in suite of tools for working with zippers and AST, as well as our off-the-shelf patchers for making project modifications. The codebase is split up into four primary divisions:\n\n- `Igniter.Project.*` - project-level, off-the-shelf patchers\n- `Igniter.Code.*` - working with zippers and manipulating source code\n- `Igniter.Mix.*` - mix tasks, tools for writing igniter mix tasks\n- `Igniter.Util.*` - various utilities and helpers","ref":"writing-generators.html#navigating-the-igniter-codebase"},{"type":"extras","title":"Configuring Igniter","doc":"# Configuring Igniter\n\nThis guide is for those who are _end-users_ of igniter, for example, using the generators provided by a library that are backed by igniter.","ref":"configuring-igniter.html"},{"type":"extras","title":"Setting up igniter - Configuring Igniter","doc":"Use `mix igniter.setup` to create a `.igniter.exs` file in your project root. This file configures igniter for your project. You can run this command repeatedly to keep the file up to date over time.\n\nSee the documentation in `Igniter.Project.IgniterConfig` for available configuration.","ref":"configuring-igniter.html#setting-up-igniter"},{"type":"extras","title":"Extensions - Configuring Igniter","doc":"Igniter supports extensions. These extensions are limited to determining where modules should be created (i.e a module in `/web` ending in `Controller`).\nThis is not bulletproof and will likely need to be improved over time. (The best thing would be if Phoenix conventions were the same as the\nelixir conventions of module names matching paths). To this end, you will want to add the phoenix extension if your generator builds any phoenix-related modules.\n\nFor an end user, this can be done with `mix igniter.add_extension phoenix`.\n\nFor those writing tasks, use `Igniter.compose_task(\"igniter.add_extension\", [\"phoenix\"])`.","ref":"configuring-igniter.html#extensions"},{"type":"extras","title":"Moving files - Configuring Igniter","doc":"One available configuration is `module_location`. This configuration dictates where modules are placed when there is a folder that exactly matches their module name. There are two available strategies for this, and with igniter not only can you change your mind, but you can actually _move back and forth_ between each strategy. To move any modules to their rightful place, use `mix igniter.move_files`.\n\n>","ref":"configuring-igniter.html#moving-files"},{"type":"extras","title":"Only for matching modules {: .tip} - Configuring Igniter","doc":">\n> The following rules are _only applied_ when a top-level module is defined in the file. If it is not, then the file will always be left exactly where it is. It is generally considered best-practice to define one top-level module per file.\n\n## `:outside_matching_folder`\n\nThe \"standard\" way to place a module is to place it in a folder path that exactly matches its module name, inside of `lib/`. For example, a module named `MyApp.MyModule` would be placed in `lib/my_app/my_module.ex`.\n\nUse the default `:outside_matching_folder` to follow this convention in all cases.\n\n## `:inside_matching_folder`\n\nWhat some people don't like about the previously described strategy is that it can split up related modules. For example:\n\n```\nlib/\n└── my_app/\n    ├── accounts/\n    │   ├── user.ex\n    │   ├── organization.ex\n    ├── social/\n    │   ├── post.ex\n    │   ├── comment.ex\n    ├── accounts.ex # <- This feels to some like it should be in `/accounts`\n    └── social.ex\n```\n\nThey would prefer to put that leaf-node module in its matching folder _if it exists_, and otherwise follow the original convention if not.\n\n```\nlib/\n└── my_app/\n    ├── accounts/\n    │   ├── user.ex\n    │   ├── organization.ex\n    │   ├── accounts.ex\n    ├── social/\n    │   ├── post.ex\n    │   ├── comment.ex\n    │   └── social.ex\n```","ref":"configuring-igniter.html#only-for-matching-modules-tip"},{"type":"extras","title":"Upgrades","doc":"# Upgrades\n\nIgniter provides a mix task `mix igniter.upgrade` that is a drop-in replacement for\n`mix deps.update`, but will run any associated `upgrade` tasks for the packages that have changed.","ref":"upgrades.html"},{"type":"extras","title":"Using Upgraders - Upgrades","doc":"In general, you can replace your usage of `mix deps.update` with `mix igniter.upgrade`. Packages that\ndon't use igniter will be updated as normal, and packages that do will have any associated upgraders run.","ref":"upgrades.html#using-upgraders"},{"type":"extras","title":"Writing Upgraders - Upgrades","doc":"To write an upgrader, your package should provide an igniter task called `your_package.upgrade`. This task\nwill take two positional arguments, `from` and `to`, which are the old and new versions of the package.\n\nWhile you are free to implement this logic however you like, we suggest using\n`mix igniter.gen.task your_package.upgrade --upgrade`, and following the patterns that are provided by the generated task.","ref":"upgrades.html#writing-upgraders"},{"type":"extras","title":"Limitations - Upgrades","doc":"","ref":"upgrades.html#limitations"},{"type":"extras","title":"Compile Compatibility - Upgrades","doc":"The new version of the package must be \"compile compatible\" with your existing code. For this reason,\nwe encourage library authors to make even _major_ versions compile compatible with previous versions, but\nthis is not always possible. For those cases, we encourage library authors to provide a version _prior_\nto their breaking changes that includs an upgrader to code that is compatible with the new version. This way,\nyou can at least instruct users to `mix igniter.upgrade package@that.version` before upgrading to the latest\nversion.","ref":"upgrades.html#compile-compatibility"},{"type":"extras","title":"Path dependencies - Upgrades","doc":"We cannot determine the old version for path dependencies, so currently there is no way to use\nthem with `mix igniter.upgrade`. We can potentially support this in the future with arguments\nlike `--old-version-  x.y.z`.","ref":"upgrades.html#path-dependencies"},{"type":"extras","title":"Upgrading in CI (i.e Dependabot) - Upgrades","doc":"The flag `--git-ci` is provided to `mix igniter.upgrade` to allow for CI integration. This flag\ncauses igniter to parse the previous versions from the `mix.lock` file prior to the current pull request.\nThis limitation does mean that only hex dependencies can be upgraded in this way.\nHere is an example set of github action steps that will run `mix igniter.upgrade` and add a commit\nfor any upgrades.","ref":"upgrades.html#upgrading-in-ci-i-e-dependabot"},{"type":"extras","title":"Limitations - Upgrades","doc":"This example setup does not trigger the github actions on your PR again. This is due to\n[intentional limitations of GITHUB_TOKEN]. You can see more here: https://github.com/stefanzweifel/git-auto-commit-action?tab=readme-ov-file#commits-made-by-this-action-do-not-trigger-new-workflow-runs\nIt is possible to work around this with a \"personal access token\". If you come up with a nice way\nto make the commit trigger another workflow, please let us know 😊.\n\n```yml\nigniter-upgrade:\n  name: mix igniter.upgrade\n  runs-on: ubuntu-latest\n  if: ${{inputs.igniter-upgrade}}\n  permissions:\n    contents: write\n  steps:\n    - name: Dependabot metadata\n      id: dependabot-metadata\n      uses: dependabot/fetch-metadata@v2\n      if: github.event.pull_request.user.login == 'dependabot[bot]'\n    - uses: actions/checkout@v3\n      with:\n        fetch-depth: 0\n        ref: ${{ github.head_ref }}\n    # This uses a `.tool-version` file for languages\n    # Feel free to use whatever steps you want to set up elixir\n    # and run the `igniter.upgrade` mix task. Just use the same flags as shown.\n    - uses: team-alembic/staple-actions/actions/mix-task@main\n      with:\n        task: igniter.upgrade --git-ci\n    - name: Commit Changes\n      uses: stefanzweifel/git-auto-commit-action@v5\n      if: github.event.pull_request.user.login == 'dependabot[bot]'\n      with:\n        commit_message: \"[dependabot skip] Apply Igniter Upgrades\"\n        commit_user_name: dependabot[bot]\n```","ref":"upgrades.html#limitations"},{"type":"extras","title":"Change Log","doc":"# Change Log\n\nAll notable changes to this project will be documented in this file.\nSee [Conventional Commits](Https://conventionalcommits.org) for commit guidelines.\n\n<!-- changelog -->\n\n## [v0.5.9](https://github.com/ash-project/igniter/compare/v0.5.8...v0.5.9) (2025-01-19)","ref":"changelog.html"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* combine comments when adding or replacing code\n\n* `Igniter.Project.MixProject.update/4` now creates non-existing functions (#190)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"* ensure phoenix /live files go where they should\n\n* Default `yes?` to Y (#197)\n\n* Add `Phoenix.select_endpoint/3` (#192)\n\n## [v0.5.8](https://github.com/ash-project/igniter/compare/v0.5.7...v0.5.8) (2025-01-06)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"* significant cleanup of deps compilation logic\n\n* suppress all output for cleaner loading spinners\n\n## [v0.5.7](https://github.com/ash-project/igniter/compare/v0.5.6...v0.5.7) (2025-01-06)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* propertly iterate over tasks list\n\n## [v0.5.6](https://github.com/ash-project/igniter/compare/v0.5.5...v0.5.6) (2025-01-05)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"* better step explanation in installer\n\n## [v0.5.5](https://github.com/ash-project/igniter/compare/v0.5.4...v0.5.5) (2025-01-05)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* only display mix.exs changes when showing them\n\n## [v0.5.4](https://github.com/ash-project/igniter/compare/v0.5.3...v0.5.4) (2025-01-05)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* don't show git warning for changes igniter made\n\n* print message after diff\n\n* allow check to pass when no issues found (#178)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"* capture and suppress output in installers (#186)\n\n* print version diff when upgrading packages (#185)\n\n* sort the `missing` packages when upgrading\r\n\n## [v0.5.3](https://github.com/ash-project/igniter/compare/v0.5.2...v0.5.3) (2024-12-26)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* ensure deps are compiled and proceed w/ install if igniter is","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"* rip out shared utils\n\n## [v0.5.2](https://github.com/ash-project/igniter/compare/v0.5.1...v0.5.2) (2024-12-25)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"* add `--yes-to-deps` option to `mix igniter.install`\n\n* add `--yes-to-deps` when using `mix igniter.new`\n\n## [v0.5.1](https://github.com/ash-project/igniter/compare/v0.5.0...v0.5.1) (2024-12-24)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* Igniter.mkdir not expanding paths correctly (#174)\n\n* handle case where third tuple elem is nil\n\n* handle mix rebar deprecations for 1.18 (#172)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"* add `prepend_to_pipeline` and `has_pipeline` to\n\n* add fallback igniter install in archive\n\n## [v0.5.0](https://github.com/ash-project/igniter/compare/v0.4.8...v0.5.0) (2024-12-19)","ref":"changelog.html#improvements"},{"type":"extras","title":"Features: - Change Log","doc":"* add Igniter.mkdir (#165)","ref":"changelog.html#features"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* set quoted default to handle regex escaping issues\n\n* parse_argv callback should be overridable (#166)\n\n* use original file's extname when moving files always","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"* default igniter installation to being optional\n\n* `Igniter.Project.MixProject.update/4` (#168)\n\n* `Igniter.Project.MixProject.update/4`\n\n* add `has_dep?/2`\n\n* add convenient wrapper around installing new packages\n\n## [v0.4.8](https://github.com/ash-project/igniter/compare/v0.4.7...v0.4.8) (2024-11-27)","ref":"changelog.html#improvements"},{"type":"extras","title":"Breaking Changes: - Change Log","doc":"* add `expand_env?` option to `Igniter.Code.Common.add_code/3` (#151)","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* if alias elements are strings ensure they aren't interpreted as AST\n\n* don't move modules back to their \"proper\" location\n\n* use new `ignore_missing_sub_formatters` option in rewrite","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"* add `:force?` option to `Igniter.Project.Application.add_new_child/3` (#156)\n\n* handle io formatting more uniformly (#148)\n\n* handle io formatting more uniformly\n\n## [v0.4.7](https://github.com/ash-project/igniter/compare/v0.4.6...v0.4.7) (2024-11-12)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"- Add `Igniter.Libs.Swoosh` for working with Swoosh","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- print a consistent number of blank lines around diffs (#147)\n\n## [v0.4.6](https://github.com/ash-project/igniter/compare/v0.4.5...v0.4.6) (2024-11-06)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- suppress module conflict warning when running upgrade_igniter\n\n- pass dot_formatter when updating rewrite sources (#144)\n\n- skip unknown deps in dot formatter","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- Add `priv_dir` functions to return priv directory (#141)\n\n## [v0.4.5](https://github.com/ash-project/igniter/compare/v0.4.4...v0.4.5) (2024-11-04)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- skip unknown deps in dot formatter\n\n## [v0.4.4](https://github.com/ash-project/igniter/compare/v0.4.3...v0.4.4) (2024-11-03)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- support replace_or_append instruction when modifying task aliases\n- Add `priv_dir` functions to return priv directory (#141)\n\n## [v0.4.3](https://github.com/ash-project/igniter/compare/v0.4.2...v0.4.3) (2024-11-02)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- various fixes for test formatting","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- Tools for removing formatter plugins & imported deps\n\n## [v0.4.2](https://github.com/ash-project/igniter/compare/v0.4.1...v0.4.2) (2024-11-02)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- properly compose upgrade tasks","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- update rewrite to 1.0.0 (#135)\n\n## [v0.4.1](https://github.com/ash-project/igniter/compare/v0.4.0...v0.4.1) (2024-11-01)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- apply 0.3 compatibility fixes for upgrades\n\n## [v0.3.77](https://github.com/ash-project/igniter/compare/v0.3.76...v0.3.77) (2024-11-01)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- don't skip igniter composition on existing issues\n\n- handle `Igniter.Project.Application.app_module/1` returning tuple\n\n- properly retain trailing newlines in `replace_code/2`\n\n- handle grouped options in positional args parsing\n\n- properly pass --with-args to generator\n\n- handle connected `=` in extract_positional_args\n\n- properly split args on equals symbol\n\n- `Igniter.Code.Common.replace_code/2`: Don't leave zipper at parent when extending blocks (#123)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- Parse `argv` by default and store in `Igniter` struct (#131)\n\n- upgrade `igniter/2` to `igniter/1` in simple cases\n\n- optimize `Igniter.Project.Module.find_module/2` when all files haven't been loaded\n\n- add `Igniter.Test.diff/2` (#120)\n\n- add `Igniter.Test.diff/2`\n\n## [v0.3.76](https://github.com/ash-project/igniter/compare/v0.3.75...v0.3.76) (2024-10-28)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- properly ignore `with-args` when passing args to installers\n\n- `expand_literal` should expand single-child blocks\n\n- `expand_literal` should return an error `Macro.expand_literals` doesn't return a literal\n\n- make task run/1 overridable (#114)\n\n- Support integer argument in `move_right/2` and `move_upwards/2` and add `move_left/2` (#113)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- resolve project app names set using a module attribute (#111)\n\n- resolve project app names set using a module attribute\n\n## [v0.3.75](https://github.com/ash-project/igniter/compare/v0.3.74...v0.3.75) (2024-10-26)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- make update_gettext idempotent\n\n## [v0.3.74](https://github.com/ash-project/igniter/compare/v0.3.73...v0.3.74) (2024-10-24)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- properly compare version lists\n\n## [v0.3.73](https://github.com/ash-project/igniter/compare/v0.3.72...v0.3.73) (2024-10-24)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- don't use `yes?` if --git_ci or --yes\n\n## [v0.3.72](https://github.com/ash-project/igniter/compare/v0.3.71...v0.3.72) (2024-10-22)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- set `--yes` automatically in git_ci\n\n## [v0.3.71](https://github.com/ash-project/igniter/compare/v0.3.70...v0.3.71) (2024-10-22)\n\n## [v0.3.70](https://github.com/ash-project/igniter/compare/v0.3.69...v0.3.70) (2024-10-22)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- properly upgrade deps with mix deps.update\n\n## [v0.3.69](https://github.com/ash-project/igniter/compare/v0.3.68...v0.3.69) (2024-10-21)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- add `mix igniter.refactor.unless_to_if_not`\n\n## [v0.3.68](https://github.com/ash-project/igniter/compare/v0.3.67...v0.3.68) (2024-10-21)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- properly detect all version migrations\n\n- make replacing code append to parent blocks when extendable\n\n- pass through additional arguments to installers\n\n- reintroduce accidentally removed function\n\n- don't call into shared lib?\n\n## [v0.3.67](https://github.com/ash-project/igniter/compare/v0.3.66...v0.3.67) (2024-10-19)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- ensure deps are always added in explicit tuple format\n\n- don't use the 2 arg version of config when the first key would be ugly\n\n## [v0.3.66](https://github.com/ash-project/igniter/compare/v0.3.65...v0.3.66) (2024-10-19)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- significant improvements to function checking speed\n\n## [v0.3.65](https://github.com/ash-project/igniter/compare/v0.3.64...v0.3.65) (2024-10-19)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"- add `mix igniter.upgrade`\n\n- add `mix igniter.refactor.rename_function`\n\n## [v0.3.64](https://github.com/ash-project/igniter/compare/v0.3.63...v0.3.64) (2024-10-17)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- don't infinitely recurse on update_all_matches\n\n- detect node removal in update_all_matches","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- add `Igniter.Code.String`\n\n## [v0.3.63](https://github.com/ash-project/igniter/compare/v0.3.62...v0.3.63) (2024-10-15)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- properly collect csv options into lists\n\n## [v0.3.62](https://github.com/ash-project/igniter/compare/v0.3.61...v0.3.62) (2024-10-14)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- properly parse csv/keep options\n\n## [v0.3.61](https://github.com/ash-project/igniter/compare/v0.3.60...v0.3.61) (2024-10-14)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- support csv option type and properly handle keep options lists\n\n## [v0.3.60](https://github.com/ash-project/igniter/compare/v0.3.59...v0.3.60) (2024-10-14)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"- don't rely on elixir 1.16+ features\n\n## [v0.3.59](https://github.com/ash-project/igniter/compare/v0.3.58...v0.3.59) (2024-10-14)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- don't return igniter from message function\n\n## [v0.3.58](https://github.com/ash-project/igniter/compare/v0.3.57...v0.3.58) (2024-10-13)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- don't assume the availabilit of `which`\n\n## [v0.3.57](https://github.com/ash-project/igniter/compare/v0.3.56...v0.3.57) (2024-10-11)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- add `group` and option disambiguation based on groups\n\n## [v0.3.56](https://github.com/ash-project/igniter/compare/v0.3.55...v0.3.56) (2024-10-11)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"- support required arguments in the info schema\n\n## [v0.3.55](https://github.com/ash-project/igniter/compare/v0.3.54...v0.3.55) (2024-10-11)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- fix pattern match on prompt on git changes\n\n## [v0.3.54](https://github.com/ash-project/igniter/compare/v0.3.53...v0.3.54) (2024-10-11)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- looser match on git change detection\n\n## [v0.3.53](https://github.com/ash-project/igniter/compare/v0.3.52...v0.3.53) (2024-10-11)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- add `on_exists` handling to `Igniter.Libs.Ecto.gen_migration`\n\n## [v0.3.52](https://github.com/ash-project/igniter/compare/v0.3.51...v0.3.52) (2024-10-07)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"- properly warn on git changes before committing\n\n## [v0.3.51](https://github.com/ash-project/igniter/compare/v0.3.50...v0.3.51) (2024-10-07)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- provide proper version in the installer","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- remove `System.cmd` for `igniter.install` in installer\n\n- allow excluding line numbers in `Igniter.Test.assert_has_patch`\n\n- prettier errors on task exits\n\n## [v0.3.50](https://github.com/ash-project/igniter/compare/v0.3.49...v0.3.50) (2024-10-07)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"- don't warn on missing installers that aren't actually missing\n\n## [v0.3.49](https://github.com/ash-project/igniter/compare/v0.3.48...v0.3.49) (2024-10-06)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- fix dialyzer spec\n\n## [v0.3.48](https://github.com/ash-project/igniter/compare/v0.3.47...v0.3.48) (2024-10-04)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- add `opts_updater` option to `add_new_child`\n\n- add `Igniter.Libs.Ecto.gen_migration`\n\n- implement various deprecations\n\n- add `Igniter.Libs.Ecto` for listing/selecting repos\n\n- add `defaults` key to `Info{}`\n\n## [v0.3.47](https://github.com/ash-project/igniter/compare/v0.3.46...v0.3.47) (2024-10-04)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- prompt users to handle diverged environment issues\n\n- display installer output in `IO.stream()`\n\n- honor --yes properly when adding nested deps\n\n- don't install revoked versions of packages\n\n- install non-rc packages, or the rc package if there is none\n\n## [v0.3.46](https://github.com/ash-project/igniter/compare/v0.3.45...v0.3.46) (2024-10-03)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- fix message in task name warning\n\n## [v0.3.45](https://github.com/ash-project/igniter/compare/v0.3.44...v0.3.45) (2024-09-25)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- use `ensure_all_started` without a list for backwards compatibility","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- Yn -> y/n to represent a lack of a default\n\n## [v0.3.44](https://github.com/ash-project/igniter/compare/v0.3.43...v0.3.44) (2024-09-24)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- properly create or update config files\n\n- format files after reading so formatter_opts is set before later writes\n\n- remove incorrect call to `add_code` from `replace_code`\n\n## [v0.3.43](https://github.com/ash-project/igniter/compare/v0.3.42...v0.3.43) (2024-09-23)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- traverse lists without entering child nodes\n\n## [v0.3.42](https://github.com/ash-project/igniter/compare/v0.3.41...v0.3.42) (2024-09-23)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- handle empty requested positional args when extracting positional","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- add `Igniter.Code.List.replace_in_list/3`\n\n- allow appending/prepending a different value when the full\n\n## [v0.3.41](https://github.com/ash-project/igniter/compare/v0.3.40...v0.3.41) (2024-09-23)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"- add `Igniter.Project.TaskAliases.add_alias/3-4`\n\n## [v0.3.40](https://github.com/ash-project/igniter/compare/v0.3.39...v0.3.40) (2024-09-23)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- properly detect existing scopes with matching names\n\n## [v0.3.39](https://github.com/ash-project/igniter/compare/v0.3.38...v0.3.39) (2024-09-18)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- don't warn while parsing files\n\n- display an error when a composed task can't be found","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- more phoenix router specific code\n\n- make `issues` red and formatted with more spacing\n\n- properly compare regex literals\n\n- add `dont_move_file_pattern` utility\n\n- update installer to always run mix deps get and install\n\n## [v0.3.38](https://github.com/ash-project/igniter/compare/v0.3.37...v0.3.38) (2024-09-16)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- don't add warning on `overwrite` option","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- better confirmation message experience\n\n## [v0.3.37](https://github.com/ash-project/igniter/compare/v0.3.36...v0.3.37) (2024-09-15)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"- return `igniter` in `Igniter.Test.assert_unchanged`\n\n## [v0.3.36](https://github.com/ash-project/igniter/compare/v0.3.35...v0.3.36) (2024-09-13)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- reevaluate .igniter.exs when it changes","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- Support for extensions in igniter config\n\n- Add a phoenix extension to prevent moving modules that may be phoenix-y\n\n## [v0.3.35](https://github.com/ash-project/igniter/compare/v0.3.34...v0.3.35) (2024-09-10)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- much smarter removal of `import_config` when evaluating configuration files\n\n- when including a glob, use `test_files` in test_mode","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- add `Igniter.Code.Common.remove/2`\n\n## [v0.3.34](https://github.com/ash-project/igniter/compare/v0.3.33...v0.3.34) (2024-09-10)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- properly avoid adding duplicate children to application tree\n\n## [v0.3.33](https://github.com/ash-project/igniter/compare/v0.3.32...v0.3.33) (2024-09-10)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- properly determine module placement in app tree\n\n## [v0.3.32](https://github.com/ash-project/igniter/compare/v0.3.31...v0.3.32) (2024-09-10)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- properly extract app module from `def project`\n\n## [v0.3.31](https://github.com/ash-project/igniter/compare/v0.3.30...v0.3.31) (2024-09-10)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- set only option to `nil` by default\n\n## [v0.3.30](https://github.com/ash-project/igniter/compare/v0.3.29...v0.3.30) (2024-09-10)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- handle some edge cases in application child adding","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- support the opts being code when adding a new child to the app tree\n\n- prepend new children instead of appending them\n\n- add an `after` option to `add_new_child/3`\n\n- better warnings on invalid patches in test\n\n## [v0.3.29](https://github.com/ash-project/igniter/compare/v0.3.28...v0.3.29) (2024-09-09)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"- check for git changes to avoid overwriting unsaved changes\n\n- add `mix igniter.gen.task` to quickly generate a full task\n\n- properly find the default location for mix task modules\n\n- add `--only` option, and `only` key in `Igniter.Mix.Task.Info`\n\n- add `Igniter.Test` with helpers for writing tests\n\n- extract app name and app module from mix.exs file\n\n## [v0.3.28](https://github.com/ash-project/igniter/compare/v0.3.27...v0.3.28) (2024-09-09)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- don't hardcode `Spark.Formatter` plugin\n\n## [v0.3.27](https://github.com/ash-project/igniter/compare/v0.3.26...v0.3.27) (2024-09-08)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- when replacing a dependency, leave it in the same location\n\n## [v0.3.26](https://github.com/ash-project/igniter/compare/v0.3.25...v0.3.26) (2024-09-08)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"- add `igniter.update_gettext`\n\n## [v0.3.25](https://github.com/ash-project/igniter/compare/v0.3.24...v0.3.25) (2024-09-06)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"- add `configure_runtime_env` codemod\n\n- remove dependencies that aren't strictly necessary\n\n- remove dependencies that we don't really need\n\n- more options to `igniter.new`\n\n## [v0.3.24](https://github.com/ash-project/igniter/compare/v0.3.23...v0.3.24) (2024-08-26)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- detect equal lists for node equality\n\n## [v0.3.23](https://github.com/ash-project/igniter/compare/v0.3.22...v0.3.23) (2024-08-26)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- properly move to arguments of Module.fun calls","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- add `Igniter.Code.Common.expand_literal/1`\n\n- add `--with-args` to pass additional args to installers\n\n## [v0.3.22](https://github.com/ash-project/igniter/compare/v0.3.21...v0.3.22) (2024-08-20)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"- add options to control behavior when creating a file that already exists\n\n## [v0.3.21](https://github.com/ash-project/igniter/compare/v0.3.20...v0.3.21) (2024-08-20)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"- add `copy_template/4`\n\n## [v0.3.20](https://github.com/ash-project/igniter/compare/v0.3.19...v0.3.20) (2024-08-19)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- ensure no timeout on task async streams\n\n- don't hardcode `Foo.Supervisor` ð¤¦\n\n## [v0.3.19](https://github.com/ash-project/igniter/compare/v0.3.18...v0.3.19) (2024-08-13)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- properly handle values vs code in configure\n\n## [v0.3.18](https://github.com/ash-project/igniter/compare/v0.3.17...v0.3.18) (2024-08-08)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- fix and test keyword setting on empty list\n\n## [v0.3.17](https://github.com/ash-project/igniter/compare/v0.3.16...v0.3.17) (2024-08-08)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- properly parse boolean switches from positional args\n\n- don't warn on `Macro.Env.expand_alias/3` not being defined\n\n- descend into single child block when modifying keyword\n\n- set `format: :keyword` when adding keyword list item to empty list\n\n- escape injected code in Common.replace_code/2 (#70)\n\n- :error consistency in remove_keyword_key and argument_equals? in Config.configure (#68)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- support for non-elixir files with create_new_file, update_file, include_existing_file, include_or_create_file, create_or_update_file (#75)\n\n- support \"notices\" (#65)\n\n## [v0.3.16](https://github.com/ash-project/igniter/compare/v0.3.15...v0.3.16) (2024-07-31)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- loadpaths after compiling deps","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- add `create_module` utility\n\n## [v0.3.15](https://github.com/ash-project/igniter/compare/v0.3.14...v0.3.15) (2024-07-31)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- remove `force?: true` from dep installation\n\n- better handling of positional args in igniter.new\n\n## [v0.3.14](https://github.com/ash-project/igniter/compare/v0.3.13...v0.3.14) (2024-07-30)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- detect more function call formats\n\n- properly extract arguments when parsing positional args\n\n## [v0.3.13](https://github.com/ash-project/igniter/compare/v0.3.12...v0.3.13) (2024-07-30)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- force compile dependencies to avoid strange compiler issues\n\n## [v0.3.12](https://github.com/ash-project/igniter/compare/v0.3.11...v0.3.12) (2024-07-30)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- add `Igniter.Libs.Phoenix.endpoints_for_router/2`\n\n## [v0.3.11](https://github.com/ash-project/igniter/compare/v0.3.10...v0.3.11) (2024-07-27)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- ensure igniter is compiled first\n\n- fetch deps after adding any nested installers\n\n- various fixes & improvements to positional argument listing","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- clean up dependency compiling logic\n\n- optimize module finding w/ async_stream\n\n- add `rest: true` option for positional args\n\n## [v0.3.10](https://github.com/ash-project/igniter/compare/v0.3.9...v0.3.10) (2024-07-26)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- recompile igniter in `ingiter.install`","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- add `positional_args!/1` macro for use in tasks\n\n- better output on missing installers & already present dep\n\n## [v0.3.9](https://github.com/ash-project/igniter/compare/v0.3.8...v0.3.9) (2024-07-22)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- force compile dependencies.\n\n- use length of path for insertion point, instead of node equality\n\n## [v0.3.8](https://github.com/ash-project/igniter/compare/v0.3.7...v0.3.8) (2024-07-19)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- better map key setting\n\n- detect strings as non extendable blocks\n\n- add option to ignore already present phoenix scopes\n\n## [v0.3.7](https://github.com/ash-project/igniter/compare/v0.3.6...v0.3.7) (2024-07-19)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- improve `add_code` by modifying the `supertree`\n\n## [v0.3.6](https://github.com/ash-project/igniter/compare/v0.3.5...v0.3.6) (2024-07-19)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- properly scope configuration modification code\n\n- properly add blocks of code together\n\n## [v0.3.5](https://github.com/ash-project/igniter/compare/v0.3.4...v0.3.5) (2024-07-19)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- properly move to pattern matches in scope\n\n- configures?/3 -> configures_key & configures_root_key (#54)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- add blocks together more fluidly in `add_code`\n\n## [v0.3.4](https://github.com/ash-project/igniter/compare/v0.3.3...v0.3.4) (2024-07-19)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- recompile `:igniter` if it has to","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- include config in include_all_elixir_files (#55)\n\n- add Function.argument_equals?/3 (#53)\n\n- add Function.argument_equals?/3\n\n## [v0.3.3](https://github.com/ash-project/igniter/compare/v0.3.2...v0.3.3) (2024-07-18)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"- fix function typespecs & add `inflex` dependency\n\n- only show executed installers (#50)\n\n- support tuple dependencies in igniter.install (#49)\n\n## [v0.3.2](https://github.com/ash-project/igniter/compare/v0.3.1...v0.3.2) (2024-07-16)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- don't compile igniter dep again when compiling deps\n\n## [v0.3.1](https://github.com/ash-project/igniter/compare/v0.3.0...v0.3.1) (2024-07-16)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- when adding code to surrounding block, don't go up multiple blocks\n\n## [v0.3.0](https://github.com/ash-project/igniter/compare/v0.2.13...v0.3.0) (2024-07-15)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- Add `Igniter.Libs.Phoenix` for working with Phoenix\n\n- deprecate duplicate `Igniter.Code.Module.move_to_use` function\n\n- `Igniter.Project.Config.configures?/4` that takes a config file\n\n- Add `Igniter.Util.Warning` for formatting code in warnings\n\n## [v0.2.13](https://github.com/ash-project/igniter/compare/v0.2.12...v0.2.13) (2024-07-15)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- remove redundant case clause in `Igniter.Code.Common`","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- make `apply_and_fetch_dependencies` only change `deps/0`\n\n- remove a bunch of dependencies by using :inets & :httpc\n\n## [v0.2.12](https://github.com/ash-project/igniter/compare/v0.2.11...v0.2.12) (2024-07-10)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- fix dialyzer warnings about info/2 never being nil\n\n## [v0.2.11](https://github.com/ash-project/igniter/compare/v0.2.10...v0.2.11) (2024-07-10)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- prevent crash on specific cases with `igniter.new`","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- more consistent initial impl of `elixirc_paths`\n\n- support :kind in find_and_update_or_create_module/5 (#38)\n\n## [v0.2.10](https://github.com/ash-project/igniter/compare/v0.2.9...v0.2.10) (2024-07-10)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"- ensure `test/support` is in elixirc paths automatically when necessary\n\n## [v0.2.9](https://github.com/ash-project/igniter/compare/v0.2.8...v0.2.9) (2024-07-09)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- simplify how we get tasks to run\n\n- don't try to format after editing `mix.exs`\n\n## [v0.2.8](https://github.com/ash-project/igniter/compare/v0.2.7...v0.2.8) (2024-07-09)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- fix deps compilation issues by vendoring `deps.compile`\n\n- honor `--yes` flag when installing deps always","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- small tweaks to output\n\n## [v0.2.7](https://github.com/ash-project/igniter/compare/v0.2.6...v0.2.7) (2024-07-09)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- remove shortnames for global options, to reduce conflicts\n\n- remove erroneous warning while composing tasks\n\n- pass file_path to `ensure_default_configs_exist` (#36)\n\n- preserve original ordering in Util.Install (#33)\n\n- include only \"mix.exs\" in the actual run in apply_and_fetch_dependencies (#32)\n\n- always return {:ok, zipper} in append_new_to_list/2 (#31)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- support an optional append? flag for add_dep/3 (#34)\n\n- add `add_dep/2-3`, that accepts a full dep specification\n\n- deprecate `add_dependency/3-4`\n\n- make module moving much smarter\n\n- add configurations for not moving certain modules\n\n- make `source_folders` configurable\n\n## [v0.2.6](https://github.com/ash-project/igniter/compare/v0.2.5...v0.2.6) (2024-07-02)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"- properly find nested modules again\n\n- make igniter tests much faster by not searching our own project\n\n- add `include_all_elixir_files/1`\n\n- add `module_exists?/2`\n\n- add `find_and_update_module/3`\n\n- only require rejecting mix deps.get one time & remember that choice\n\n- simpler messages signaling a mix deps.get\n\n## [v0.2.5](https://github.com/ash-project/igniter/compare/v0.2.4...v0.2.5) (2024-07-02)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"- `move_modules` -> `move_files`\n\n- move some files around and update config names\n\n- use `%Info{}` structs to compose and plan nested installers\n\n- add Igniter.apply_and_fetch_dependencies/1 and Igniter.has_changes?/1 (#28)\n\n- rename option_schema/2 -> info/2\n\n- only create default configs if an env-specific config is created\n\n## [v0.2.4](https://github.com/ash-project/igniter/compare/v0.2.3...v0.2.4) (2024-06-28)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- fix match error in `append_new_to_list`\n\n- version string splitting (#25)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- add an optional path argument to `find_and_update_or_create_module/5`\n\n- add `option_schema/2` callback to `Igniter.Mix.Task`\n\n- `Module.find_and_update_or_create_module`\n\n- add a way to move files\n\n- add `.igniter.exs` file, and `mix igniter.setup` to create it\n\n- move files to configured location based on changes\n\n- add fallback to compose_task (#19)\n\n- add proper_test_support_location/1 (#18)\n\n- add proper_test_location/1 (#17)\n\n## [v0.2.3](https://github.com/ash-project/igniter/compare/v0.2.2...v0.2.3) (2024-06-21)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"- use `override: true` for git/github deps as well\n\n## [v0.2.2](https://github.com/ash-project/igniter/compare/v0.2.1...v0.2.2) (2024-06-21)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- don't show unnecessary diff output\n\n- don't compile before fetching deps\n\n## [v0.2.1](https://github.com/ash-project/igniter/compare/v0.2.0...v0.2.1) (2024-06-21)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- workaround trailing comment issues w/ sourceror\n\n- support `--with` option in `igniter.new`\n\n## [v0.2.0](https://github.com/ash-project/igniter/compare/v0.1.8...v0.2.0) (2024-06-20)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"- make installer use `override: true` on local dependency\n\n- ensure dependencies are compiled after `mix deps.get`\n\n- use warnings instead of errors for better UX\n\n- move proejct related things to `Project` namespace\n\n## [v0.1.8](https://github.com/ash-project/igniter/compare/v0.1.7...v0.1.8) (2024-06-19)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- update spitfire for env fix","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- rename `env_at_cursor` to `current_env`\n\n- improve marshalling of spitfire env to macro env\n\n- show warning when adding dependencies by default\n\n## [v0.1.7](https://github.com/ash-project/igniter/compare/v0.1.6...v0.1.7) (2024-06-14)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"- various restructurings and improvements across the board\n\n- use `Spitfire` to ensure that aliases are considered when comparing modules\n\n- use `Spitfire` to _use_ any existing aliases when inserting code\n\n- use `Zipper.topmost` to power new `Spitfire`-related features\n\n## [v0.1.6](https://github.com/ash-project/igniter/compare/v0.1.5...v0.1.6) (2024-06-13)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- patch formatter fix, to be removed later when rewrite PR is merged\n\n- properly find functions in scope\n\n## [v0.1.5](https://github.com/ash-project/igniter/compare/v0.1.4...v0.1.5) (2024-06-13)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- Igniter.Code.Common.with/2 was not properly merging with original zipper\n\n## [v0.1.4](https://github.com/ash-project/igniter/compare/v0.1.3...v0.1.4) (2024-06-13)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- use `path:` prefix instead of `local:`\n\n## [v0.1.3](https://github.com/ash-project/igniter/compare/v0.1.2...v0.1.3) (2024-06-13)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"- support space-separated installers\n\n## [v0.1.2](https://github.com/ash-project/igniter/compare/v0.1.1...v0.1.2) (2024-06-13)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- remove unsupportable package installation symbols\n\n- don't run `mix deps.get` if dependency changes are aborted\n\n## [v0.1.1](https://github.com/ash-project/igniter/compare/v0.1.0...v0.1.1) (2024-06-13)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- always format the file even if no `.formatter.exs` exists\n\n## [v0.1.0](https://github.com/ash-project/igniter/compare/v0.1.0...v0.1.0) (2024-06-13)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"- handle existing deps when they are not local properly","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"- ignore installer tasks that are not igniter tasks\n\n- draw the rest of the owl\n\n- add installer archive\n\n- more module helpers\n\n- wrap code in `==code==` so you can tell what is being `puts`\n\n- add CI/build and get it passing locally","ref":"changelog.html#improvements"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}